
# line 2 "hoc.y"
#include "hoc.h"

#define __my_yylex			/* for SGI yacc and C++ */

#if defined(YYDEBUG)
extern int yydebug;
#else
#define YYDEBUG 0	/* so this works with byacc, bison, and yacc */
#endif

/* We need larger internal yacc tables to get consistent results across
   platforms for test/long-operand.hoc */
#define YYMAXDEPTH	8000
#define YYSTACKSIZE	8000

#if defined(HAVE_CTYPE_H)
#include <ctype.h>
#endif

#if defined(HAVE_ERRNO_H)
#include <errno.h>
#endif

#if defined(HAVE_LOCALE_H)
#include <locale.h>
#endif

#if defined(HAVE_SETJMP_H)
#include <setjmp.h>
#endif

#if defined(HAVE_SIGNAL_H)
#include <signal.h>
#endif

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" int yylex ARGS((void));
extern "C" void fpecatch ARGS((int dummy));
extern "C" void intcatch ARGS((int dummy));
extern "C" void xcpucatch ARGS((int dummy));
#else
int yylex ARGS((void));
void fpecatch ARGS((int dummy));
void intcatch ARGS((int dummy));
void xcpucatch ARGS((int dummy));
#endif

#if defined(_AIX)
#undef YYCONST
#define YYCONST
EXTERN void yyerror ARGS((YYCONST char *)); /* otherwise used before prototyped on this system, sigh...*/
#endif

#if defined(HAVE_STDIO_H)
#include <stdio.h>
#endif

#if defined(HAVE_STDLIB_H)
#include <stdlib.h>
#endif

#if defined(HAVE_STRING_H)
#include <string.h>
#endif

#if defined(HAVE_UNISTD_H)
#include <unistd.h>
#endif

#if !defined(R_OK)
#define R_OK 04
#endif

#if !defined(HOCRC)
#define HOCRC	".hocrc"
#endif

#if !defined(SYSHOCDIR)
#define SYSHOCDIR	"/usr/local/share/lib/hoc/hoc-" PACKAGE_VERSION "/"
#endif

#if !defined(SYSHOCHLPBASE)
#define SYSHOCHLPBASE	"help.hoc"
#endif

#if !defined(SYSHOCHLP)
#define SYSHOCHLP SYSHOCDIR "/" SYSHOCHLPBASE
#endif

#if !defined(SYSHOCRCBASE)
#define SYSHOCRCBASE	"hoc.rc"
#endif

#if !defined(SYSHOCRC)
#define SYSHOCRC SYSHOCDIR "/" SYSHOCRCBASE
#endif

#if !defined(SYSHOCXLTBASE)
#define SYSHOCXLTBASE	"translations.hoc"
#endif

#if !defined(SYSHOCXLT)
#define SYSHOCXLT SYSHOCDIR "/" SYSHOCXLTBASE
#endif

#define	code2(c1,c2)		code(c1); (void)code(c2)
#define	code3(c1,c2,c3)		code2(c1,c2); (void)code(c3)
#define	code4(c1,c2,c3,c4)	code3(c1,c2,c3); (void)code(c4)
#define CODE(c1)		(void)code(c1)
#define CODE2(c1,c2)		(void)code2(c1,c2)
#define CODE3(c1,c2,c3)		(void)code3(c1,c2,c3)
#define CODE4(c1,c2,c3,c4)	(void)code4(c1,c2,c3,c4)
#define QUOTATION_MARK	'"'

extern const char *	elementsep;	/* defined in io.c */

int			indef;			/* needed in code.c too */
const char *		syshocdir = SYSHOCDIR;

static int		this_c = '\n';		/* file global: used in warning(), yygetid(), yylex() */
static int		infile_count = 0;
static const char *	hocrc = HOCRC;
static const char *	syshochlp = SYSHOCHLP;
static const char *	syshochlpbase = SYSHOCHLPBASE;
static const char *	syshocrc = SYSHOCRC;
static const char *	syshocrcbase = SYSHOCRCBASE;
static const char *	syshocxlt = SYSHOCXLT;
static const char *	syshocxltbase = SYSHOCXLTBASE;

extern FILE *		Fopen ARGS((const char *, const char *, const char **));
extern FILE *		Freopen ARGS((const char *, const char *, FILE*, const char **));

int			main ARGS((int, char *[]));
const char *		yygetstr ARGS((void));		/* used in code.c:varread() */
void			set_filename ARGS((const char *)); /* used in string.c:Load() */

static void             author_and_die ARGS((void));
static int		backslash ARGS((int));
static void             bump_lineno ARGS((void));
static void             copyright_and_die ARGS((void));
static void             defnonly ARGS((const char *));
static void		do_define ARGS((const char *));
static void		do_one_init_file ARGS((const char *filename));
static void		do_undefine ARGS((const char *));
static void             do_init_files ARGS((void));
static void             do_post_args ARGS((int *, char *[]));
static void             do_pre_args ARGS((const int *, const char *[]));
static void		error ARGS((const char *, const char *));
static int              follow ARGS((int, int, int));
static const char *     get_locale_filename ARGS((const char *, const char *));
static const char *     get_locale_name ARGS((void));
static void             help_and_die ARGS((void));
static void             init_lineno ARGS((void));
static void		init_locale ARGS((void));
static void		init_readline ARGS((void));
static void             show ARGS((const char *[]));
static void             usage ARGS((void));
static void             usage_and_die ARGS((const char *));
static void             version_and_die ARGS((void));


# line 163 "hoc.y"
typedef union
#ifdef __cplusplus
	YYSTYPE
#endif
 {
	Symbol	*sym;	/* symbol table pointer */
	Inst	*inst;	/* machine instruction */
	long	narg;	/* number of arguments */
} YYSTYPE;
# define NUMBER 257
# define STRING 258
# define PRINT 259
# define VAR 260
# define UNDEF 261
# define WHILE 262
# define FOR 263
# define IF 264
# define ELSE 265
# define FUNCTION 266
# define PROCEDURE 267
# define RETURN 268
# define FUNC 269
# define PROC 270
# define READ 271
# define ABORT 272
# define BLTIN0 273
# define BLTIN1 274
# define BLTIN2 275
# define DEFINED 276
# define DELETE 277
# define HEX 278
# define HEXFP 279
# define HEXINT 280
# define INDEX 281
# define LENGTH 282
# define NUMTOSTR 283
# define PRINTF 284
# define PRINTLN 285
# define STRBLTIN0 286
# define STRBLTIN1 287
# define STRBLTIN2 288
# define STRVAR 289
# define STRFTIME 290
# define STRTONUM 291
# define STRTOSYMNUM 292
# define STRTOSYMSTR 293
# define SUBSTR 294
# define ARG 295
# define STRARG 296
# define ADDEQ 297
# define SUBEQ 298
# define MULEQ 299
# define DIVEQ 300
# define MODEQ 301
# define CONSTEQ 302
# define OR 303
# define AND 304
# define GT 305
# define GE 306
# define LT 307
# define LE 308
# define EQ 309
# define NE 310
# define LTGT 311
# define UNARYMINUS 312
# define UNARYPLUS 313
# define NOT 314
# define INC 315
# define DEC 316
# define TO_POWER 317

#include <inttypes.h>

#ifdef __STDC__
#include <stdlib.h>
#include <string.h>
#define	YYCONST	const
#else
#include <malloc.h>
#include <memory.h>
#define	YYCONST
#endif

#include <values.h>

#if defined(__cplusplus) || defined(__STDC__)

#if defined(__cplusplus) && defined(__EXTERN_C__)
extern "C" {
#endif
#ifndef yyerror
#if defined(__cplusplus)
	void yyerror(YYCONST char *);
#endif
#endif
#ifndef yylex
	int yylex(void);
#endif
	int yyparse(void);
#if defined(__cplusplus) && defined(__EXTERN_C__)
}
#endif

#endif

#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
YYSTYPE yylval;
YYSTYPE yyval;
typedef int yytabelem;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
#if YYMAXDEPTH > 0
int yy_yys[YYMAXDEPTH], *yys = yy_yys;
YYSTYPE yy_yyv[YYMAXDEPTH], *yyv = yy_yyv;
#else	/* user does initial allocation */
int *yys;
YYSTYPE *yyv;
#endif
static int yymaxdepth = YYMAXDEPTH;
# define YYERRCODE 256

# line 421 "hoc.y"

	/* end of grammar */

#ifndef YYCONST
#define YYCONST				/* symbol used by Sun Solaris yacc */
#endif

#if defined(__osf__)
EXTERN void yyerror ARGS((YYCONST char *));	/* keep C++ compilers happy */
#endif

#include "readline.h"

#undef getc
#define getc(fpin)			irl_getchar(fpin)
#undef ungetc
#define ungetc(c,fpin)			irl_unget_char(c)
#undef fscanf
#define fscanf(fpin,format,pdata)	irl_fscanf(fpin,format,pdata)

#define ARGMATCH(arg,option,minmatch) (strncmp(arg,option,MAX(strlen(arg),minmatch)) == 0)
#undef MAX				/* because some systems define this already */
#define MAX(a,b)	(((a) > (b)) ? (a) : (b))
#define OPTCHAR		'-'

extern FILE *fplog;

int cd_pwd_enabled = 1;	  		/* reset by --no-cd and --secure command-line options */
int file_trace_enabled = 1;		/* reset by --secure command-line option */
int load_enabled = 1;			/* reset by --no-load and --secure command-line options */
int logfile_enabled = 1;		/* reset by --no-logfile and --secure command-line options */
int save_enabled = 1;			/* reset by --no-save and --secure command-line options */
int use_readline = 1;			/* reset by --no-readline command-line option */
static int print_banner = 1;   		/* reset by --no-banner command-line option */
static int read_help_file = 1;		/* reset by --no-help-file command-line option */
static int read_site_file = 1;		/* reset by --no-site-file command-line option */
static int read_translation_file = 1;	/* reset by --no-translation-file command-line option */
static int read_user_file = 1;		/* reset by --no-user-file command-line option */
static int verbose_mode = 1;   		/* reset by --silent command-line option */

static jmp_buf		begin;
static int		gargc;
static char		**gargv;	/* global argument list */
static const char	*infile;	/* input file name */
static int		lineno = 1;
const char		*progname;

FILE			*fin;		/* input file pointer (also used in code.c and string.c) */

static void
author_and_die(void)
{
	static const char *text[] =
	{
		PACKAGE_NAME, " was written by\n\n",

		"\tBrian W. Kernighan and Rob Pike\n\n",

		"and described in their book:\n\n",

		"\tThe UNIX Programming Environment\n",
		"\tPrentice-Hall\n",
		"\t1984\n",
		"\tpp. xii + 357\n",
		"\tISBN 0-13-937699-2 (hardcover), 0-13-937681-X (paperback)\n",
		"\tLCCN QA76.76.O63 K48 1984\n\n",

		"Extensions for IEEE 754 arithmetic, help, additional constants,\n",
		"statements, and functions, initialization files, internationalization,\n",
		"and GNU readline support were added by:\n\n",

		"\t", PACKAGE_BUGREPORT, "\n\n",

		"The extended hoc master Internet source distribution site is at:\n\n",

		"\tftp://ftp.math.utah.edu/pub/hoc\n",
		"\thttp://www.math.utah.edu/pub/hoc/\n\n",

		(const char *)NULL,
	};
	show(text);
	exit(EXIT_SUCCESS);
}

static int
backslash(int c)	/* get next char with \'s interpreted */
{
	static char transtab[] = "a\007b\bf\fn\nr\rt\tv\v"; /* K&R and Standard C escapes */

#define is_odigit(x) (isdigit(x) && (x != '8') && (x != '9'))

	if (c != '\\')
		return c;
	c = getc(fin);
	if (c == '\n')
		bump_lineno();
	if (islower(c) && (strchr(transtab, c) != (char *)NULL))
		return strchr(transtab, c)[1];
	else if (c == 'E')		/* \E -> ESCape */
	{
		/* NB: Standard C reserves uppercase escapes to
		   implementation-specific extensions */

		return ('\033');	/* ASCII ESCape */
	}
	else if (is_odigit(c))
	{		 /* \o, \oo, \ooo -> octal character number */
		int n;
		int value;

		n = 0;
		value = 0;
		while (is_odigit(c) && ((++n) <= 3))
		{
			value = 8*value + (c - (int)'0');
			c = getc(fin);
		}
		(void)ungetc(c,fin);
		return (value);
	}
	else if (c == (int)'x')
	{	/* \xhhhh... (any number of h's) -> hexadecimal character number */
		int value;

		value = 0;
		c = getc(fin);
		while (isxdigit(c))
		{
			if (isupper(c))
				c = tolower(c);
			if (((int)'a' <= c) && (c <= (int)'f'))
				value = 16*value + (c - (int)'a' + 10);
			else if (isdigit(c))
				value = 16*value + (c - (int)'0');
			c = getc(fin);
		}
		(void)ungetc(c,fin);
		return (value);
	}
	return c;

#undef is_odigit
}

static void
bump_lineno(void)
{
#if 0
	/* temporarily suppressed: see io.c:run3() header comments for why */

	static fp_t * pdlineno = (fp_t*)NULL;

	if (pdlineno == (fp_t*)NULL)
	{
		Symbol *s;

		s = lookup("__LINENO__");
		if (s == (Symbol*)NULL)
			s = install_number("__LINENO__", FP(0.0));
		make_immutable(s); /* to prevent user code assignments */
		pdlineno = &s->u.val;
	}
	lineno++;
	*pdlineno = (fp_t)lineno;	/* update __LINENO__ value in symbol table */
#else
	/* We need this alternate version of line number incrementing to match code in io.c:run3() */
	Symbol *s;
	s = lookup("__LINENO__");
	if (s == (Symbol*)NULL)
		s = install_number("__LINENO__", FP(0.0));
	if (lineno == -1)		/* special case of new input file */
		s->u.val = (fp_t)lineno;
	s->u.val += FP(1.0);
	lineno = (int)(s->u.val);
#endif
}

static void
copyright_and_die(void)
{
	static const char *text[] =
	{
		"\n",
		"=================================================================\n",
		"Copyright (C) AT&T 1995\n",
		"All Rights Reserved\n\n",

		"Permission to use, copy, modify, and distribute this software and\n",
		"its documentation for any purpose and without fee is hereby\n",
		"granted, provided that the above copyright notice appear in all\n",
		"copies and that both that the copyright notice and this\n",
		"permission notice and warranty disclaimer appear in supporting\n",
		"documentation, and that the name of AT&T or any of its entities\n",
		"not be used in advertising or publicity pertaining to\n",
		"distribution of the software without specific, written prior\n",
		"permission.\n\n",

		"AT&T DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE,\n",
		"INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS.\n",
		"IN NO EVENT SHALL AT&T OR ANY OF ITS ENTITIES BE LIABLE FOR ANY\n",
		"SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES\n",
		"WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER\n",
		"IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION,\n",
		"ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF\n",
		"THIS SOFTWARE.\n",
		"=================================================================\n\n",

		(const char *)NULL,
	};
	show(text);
	exit(EXIT_SUCCESS);
}

static void
defnonly(const char *s)	/* warn if illegal definition */
{
	if (!indef)
		execerror(s, "used outside definition");
}

static void
do_define(const char *s)
{	/* expect name (== name=1) or name=numericvalue or name=name or name="string" */
	/* (= may be replaced by := for permanent assignments) */
	char *equals;
	char *t;

	t = (char *)dupstr(s);
	equals = strchr(t,'=');
	if (equals == (char *)NULL)
	{
		if (is_immutable(t))
			error("illegal reassignment to immutable named constant", s);
		else
			(void)update_number(t,FP(1.0));	/* -Dname means -Dname=1 */
	}
	else					/* have -Dname=something or -Dname:=permanent-something */
	{
		char *value;
		int immutable;

		immutable = (equals[-1] == ':');

		if (immutable)
			equals[-1] = '\0';
		else
			equals[0] = '\0';

		if (is_immutable(t))
			error("illegal reassignment to immutable named constant", s);

		value = equals + 1;
		if (*value == QUOTATION_MARK) /* have name="value" */
		{
			char *q;

			value++;
			q = strchr(value, QUOTATION_MARK);
			if (q == (const char *)NULL)
				error("unclosed quotation mark in command-line option", s);
			else if (q[1] == '\0')
			{
				const char *v;

				*q = '\0';
				v = Expand(value);
				if (immutable)
					(void)update_const_string(t,v);
				else
					(void)update_string(t,v);
				efree((void *)v);
			}
			else
				error("unrecognized string in definition", s);
		}
		else if (IsIdStart(*value)) /* have name=name */
		{
			Symbol *sp;

			sp = lookup(value);
			if (sp == (Symbol*)NULL)
				error("unknown symbol in definition", s);
			else if (sp->type == VAR)
			{
				if (immutable)
					(void)update_const_number(t, sp->u.val);
				else
					(void)update_number(t, sp->u.val);
			}
			else if (sp->type == STRVAR)
			{
				if (immutable)
					(void)update_const_string(t, sp->u.str);
				else
					(void)update_string(t, sp->u.str);
			}
			else
				error("illegal symbol in definition", s);
		}
		else /* expect name=numeric-value */
		{
			char *endptr;
			fp_t d;

			d = strton(value, &endptr);
			if (*endptr == '\0')
			{
				if (immutable)
					(void)update_const_number(t, d);
				else
					(void)update_number(t, d);
			}
			else
				error("unrecognized number in definition", s);
		}
	}
	efree((void *)t);
}

static void
do_init_files(void)
{
	/* Process the optional startup files in documented
	   (in "man hoc") order of use:
		(1) system hoc.rc
		(2) locale hoc.rc
		(3) system help.hoc
		(4) locale help.hoc
		(5) system translations.hoc
		(6) locale translations.hoc
		(7) user .hocrc
	*/

	if (read_site_file)
	{
		do_one_init_file(syshocrc);
		do_one_init_file(get_locale_filename(syshocdir, syshocrcbase));
	}

	if (read_help_file)
	{
		do_one_init_file(syshochlp);
		do_one_init_file(get_locale_filename(syshocdir, syshochlpbase));
	}

	if (read_translation_file)
	{
		do_one_init_file(syshocxlt);
		do_one_init_file(get_locale_filename(syshocdir, syshocxltbase));
	}

#if defined(HAVE_UNIX_HOME_DIRECTORY)
	if (read_user_file)
	{
		const char * userhocrc;
		const char * home;

		home = getenv("HOME");
		if (home == (const char *)NULL)
			return;
		userhocrc = concat3(home, "/", hocrc);
		do_one_init_file(userhocrc);
		efree((void *)userhocrc);
	}
#endif
}

static void
do_one_init_file(const char *filename)
{
	const char *new_filename;

	/* If filename is readable, attempt to open it and process it.  Otherwise,
	   return silently. */
	if ((filename != (const char *)NULL) && (access(filename, R_OK) == 0))
	{
		fin = Fopen(filename, "r", &new_filename);
		if (fin == (FILE*)NULL)
		{
			(void)fprintf(stderr,
				      msg_translate("%s: can't open %s\n"),
				      progname, filename);
		}
		else
		{
			set_filename(new_filename);
			run();
			(void)fclose(fin);
			fin = (FILE*)NULL;
		}
	}
}

static void
do_post_args(int *pargc, char * argv[])
{
	int k, m;
	char *p;

	/* Process command-line arguments after initialization files
	   have been read.  Any options that are recognized are
	   removed from argv[], and *pargc is reduced accordingly. */

	for (k = 1; k < *pargc; ++k)
	{
		p = argv[k];
		if (p[0] == OPTCHAR)
		{
			p++;
			if (p[0] == OPTCHAR)
				++p;	/* support GNU/POSIX style --option */

			if (strcmp(p,"") == 0) /* ignore "-" option (meaning, stdin) */
			{
				if (p == (argv[k] + 2))
					p[-1] = '\0'; /* convert "--" to "-" */
				continue;
			}
			else if (*p == 'D')
				noop();	/* already handled in do_pre_args() */
			else if (*p == 'U')
				noop();	/* already handled in do_pre_args() */
			else if (ARGMATCH(p,"author",1))
				author_and_die();
			else if (ARGMATCH(p,"copyright",1))
				copyright_and_die();
			else if (ARGMATCH(p,"?",1))
				help_and_die();
			else if (ARGMATCH(p,"help",1))
				help_and_die();
			else if (ARGMATCH(p,"no-banner",4))
			{
				print_banner = 0;
				(void)update_number("__BANNER__", (fp_t)print_banner);
			}
			else if (ARGMATCH(p,"no-cd",4))
				cd_pwd_enabled = 0;
			else if (ARGMATCH(p,"no-help-file",4))
				read_help_file = 0;
			else if (ARGMATCH(p,"no-load",6))
				load_enabled = 0;
			else if (ARGMATCH(p,"no-logfile",6))
				logfile_enabled = 0;
			else if (ARGMATCH(p,"no-readline",4))
			{
				use_readline = 0;
				(void)update_number("__READLINE__", (fp_t)use_readline);
			}
			else if (ARGMATCH(p,"no-save",5))
				save_enabled = 0;
			else if (ARGMATCH(p,"no-site-file",5))
				read_site_file = 0;
			else if (ARGMATCH(p,"no-translation-file",4))
				read_translation_file = 0;
			else if (ARGMATCH(p,"no-user-file",4))
				read_user_file = 0;
			else if (ARGMATCH(p,"quick",1))
			{
				read_help_file = 0;
				read_site_file = 0;
				read_translation_file = 0;
				read_user_file = 0;
			}
			else if (ARGMATCH(p,"secure",2))
			{
				cd_pwd_enabled = 0;
				load_enabled = 0;
				logfile_enabled = 0;
				save_enabled = 0;
				file_trace_enabled = 0;
			}
			else if (ARGMATCH(p,"silent",1)) /* NB: can be abbreviated to 1 char */
			{
				verbose_mode = 0;
				(void)update_number("__VERBOSE__", (fp_t)verbose_mode);
			}
			else if (ARGMATCH(p,"version",1))
				version_and_die();
			else
				usage_and_die(argv[k]);
			/* Remove the option from the argument list */
			for (m = k + 1; m < (*pargc); ++m)
				argv[m-1] = argv[m];
			(*pargc)--;
			k--;	/* avoid missing the next argument */
		}
	}
	argv[*pargc] = (char *)NULL;	/* ANSI C89 Section 2.1.2.2.1: ``argv[argc] shall be a NULL pointer'' */

#if !defined(HAVE_GNU_READLINE)
	use_readline = 0;
	(void)update_number("__READLINE__", (fp_t)use_readline);
#endif

	make_immutable(lookup("__READLINE__"));	/* this decision may someday be changed */
}

static void
do_pre_args(const int *pargc, const char * argv[])
{
	int k;
	const char *p;

	(void)update_string("__FILE__", "command-line"); /* in case error() is called */

	/* Process those command-line arguments that need to be seen
	   before initialization files are read.  No errors are raised
	   here for unrecognized arguments; that will be done in
	   do_post_args().  *pargc and argv[] are left intact. */

	for (k = 1; k < *pargc; ++k)
	{
		p = argv[k];
		if (p[0] == OPTCHAR)
		{
			p++;
			if (p[0] == OPTCHAR)
				++p; /* support GNU/POSIX style --option */

			if (ARGMATCH(p,"no-banner",4))
			{
				print_banner = 0;
				(void)update_number("__BANNER__", (fp_t)print_banner);
			}
			else if (ARGMATCH(p,"no-help-file",4))
				read_help_file = 0;
			else if (ARGMATCH(p,"no-logfile",6))
				logfile_enabled = 0;
			else if (ARGMATCH(p,"no-readline",4))
			{
				use_readline = 0;
				(void)update_number("__READLINE__", (fp_t)use_readline);
			}
			else if (ARGMATCH(p,"no-site-file",5))
				read_site_file = 0;
			else if (ARGMATCH(p,"no-translation-file",4))
				read_translation_file = 0;
			else if (ARGMATCH(p,"no-user-file",4))
				read_user_file = 0;
			else if (ARGMATCH(p,"quick",1))
			{
				read_help_file = 0;
				read_site_file = 0;
				read_translation_file = 0;
				read_user_file = 0;
			}
			else if (ARGMATCH(p,"silent",1)) /* can be abbreviated to 1 character */
			{
				verbose_mode = 0;
				(void)update_number("__VERBOSE__", (fp_t)verbose_mode);
			}
			else if (*p == 'D')
				do_define(p+1);
			else if (*p == 'U')
				do_undefine(p+1);
		}
	}
}

static void
do_undefine(const char *s)
{
	if (!delete_symbol(lookup(s)))
		error("deletion failed for symbol", s);
}

static void
error(const char *s, const char *t)
{
	warning(s,t);
	exit(EXIT_FAILURE);
}

void
execerror(const char * s, const char * t)	/* recover from run-time error */
{
	warning(s, t);
	(void)fseek(fin, 0L, 2);	/* flush rest of file */
	longjmp(begin, 0);
}

#if defined(__sgi)
#include <sys/fpu.h>

static void
flush_to_zero(int on_off)		/* see "man sigfpe" on SGI IRIX 6.x for documentation */
{
	union fpc_csr n;

	n.fc_word = get_fpc_csr();
	n.fc_struct.flush = (on_off ? 1 : 0);
	set_fpc_csr(n.fc_word);
}
#endif

static int
follow(int expect, int ifyes, int ifno)	/* look ahead for >=, etc. */
{
	int ch = getc(fin);

	if (ch == expect)
		return ifyes;
	(void)ungetc(ch, fin);
	return ifno;
}

void
fpecatch(int dummy)	/* catch floating point exceptions */
{
	execerror("floating point exception", (const char *)NULL);
}

static const char *
get_locale_filename(const char *dirname, const char *basename)
{
	/* Given dirname = "/x/y/z" and basename == "foo.bar", return
	   "/x/y/z/LOCALENAME/foo.bar", where LOCALENAME is obtained from
	   get_locale_name() */
	const char *locale;

	locale = get_locale_name();
	if (locale == (const char *)NULL)
		return ((const char *)NULL);
	else
		return (concat5(dirname, "/", locale, "/", basename));
}

static const char *
get_locale_name(void)
{
	/* According to "man 3c setlocale", the language of text
	messages is determined by the locale variable LC_MESSAGES: its
	value is set by the first-defined of three environment
	variables. */

	const char *locale_name;

	locale_name = getenv("LC_ALL");
	if (locale_name == (const char *)NULL)
		locale_name = getenv("LC_MESSAGES");
	if (locale_name == (const char *)NULL)
		locale_name = getenv("LANG");
	return (locale_name);
}

const char *
get_prompt(void)
{
	Symbol *s;

	s = lookup("__PROMPT__");
	if (s == (Symbol*)NULL)
		s = install_string("__PROMPT__", (PACKAGE_NAME "> "));
	return (s->u.str);
}

int
get_verbose(void)
{
	Symbol *s;

	s = lookup("__VERBOSE__");
	if (s == (Symbol*)NULL)
		(void)install_number("__VERBOSE__", (fp_t)verbose_mode);
	else
		verbose_mode = (s->u.val != FP(0.0));
	return (verbose_mode);
}

static void
help_and_die(void)
{
	static const char *text[] =
	{
		"\n",
		"For additional help, try ", PACKAGE_NAME, "'s help() command, or in a shell,\n",
		"use the UNIX manual page command, man ", PACKAGE_NAME, ".\n",

		(const char *)NULL,
	};

	usage();
	show(text);
	exit(EXIT_SUCCESS);
}

static void
init_fp_system(void)
{
	/* Do an system-dependent initializations of the
	   floating-point arithmetic system to enable full IEEE 754
	   support, if possible. */

#if defined(__sgi)
	flush_to_zero(0);		/* to get support for subnormals! */
#endif

}

static void
init_limits(void)
{
	/* Set all of the dynamic table sizes so that they can be
	   queried even before their corresponding arrays have been
	   allocated. */
	(void)update_const_number("__MAX_FRAME__", FP(0.0));
	(void)update_const_number("__MAX_LINE__", FP(0.0));
	(void)update_const_number("__MAX_NAME__", FP(0.0));
	(void)update_const_number("__MAX_PROG__", FP(0.0));
	(void)update_const_number("__MAX_PUSHBACK__",FP(0.0));
	(void)update_const_number("__MAX_STACK__", FP(0.0));
	(void)update_const_number("__MAX_STRING__", FP(0.0));
	(void)update_const_number("__MAX_TOKEN__", FP(0.0));
}

static void
init_lineno(void)
{
	EOF_flag = 0;

	/* Because hoc evaluation happens AFTER complete lines have
	   been read, we start lineno at 0, so that, e.g.,

		println __LINENO__

	on line 1 will print 1, not 2. */

	lineno = -1;
	bump_lineno();
}

static void
init_locale(void)
{
#if defined(HAVE_LOCALE_H)
	/* These calls internationalize the hoc language!  However, in
	   order for existing programs to work, numbers MUST use a
	   decimal point, NOT a comma (or other character).  Without
	   this setting, strtod(), fscanf(), and *printf() all alter
	   number formats to locale-specific conventions.  Similarly,
	   settings other than "C" would violate assumptions about
	   sorting in the who() function, and time stamps in the now()
	   function. */

	const char *locale_name;

	locale_name = get_locale_name();
	if (locale_name != (const char *)NULL)
		(void)setlocale(LC_ALL, locale_name);
	(void)setlocale(LC_COLLATE,	"C");
	(void)setlocale(LC_CTYPE,	"C");
	(void)setlocale(LC_MONETARY,	"C");

#if defined(LC_MESSAGES)		/* POSIX.2 extension beyond C89, C++98, and C99 */
	(void)setlocale(LC_MESSAGES,	"C");
#endif

	(void)setlocale(LC_NUMERIC,	"C");
	(void)setlocale(LC_TIME,	"C");
#endif /* defined(HAVE_LOCALE_H) */
}

static void
init_readline(void)
{
#if defined(HAVE_GNU_READLINE)
	(void)rl_bind_key ('\t', rl_insert);	/* TAB is normal, NOT filename completer */
	(void)rl_bind_key ('\033', rl_complete); /* put filename completion on ESCape */
	irl_fd_stdin = dup(fileno(stdin)); /* save handle for original stdin */
#endif
}

static void
init_symbols(void)
{
	(void)update_number("__BANNER__", (fp_t)print_banner); /* so -no-banner setting is available to user code */
	(void)update_number("__READLINE__", (fp_t)use_readline); /* so -no-readline setting is available to user code */
	(void)update_number("__VERBOSE__",(fp_t)verbose_mode); /* so -silent setting is available to user code */

#if defined(HAVE_IEEE_754)
	(void)install_const_number("__IEEE_754__", FP(1.0));
#else
	(void)install_const_number("__IEEE_754__", FP(0.0));
#endif

#if defined(HAVE_ACOSH)
	(void)install_const_number("__NATIVE_ACOSH__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_ACOSH__", FP(0.0));
#endif

#if defined(HAVE_ACOSH)
	(void)install_const_number("__NATIVE_ACOSH__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_ACOSH__", FP(0.0));
#endif

#if defined(HAVE_ASINH)
	(void)install_const_number("__NATIVE_ASINH__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_ASINH__", FP(0.0));
#endif

#if defined(HAVE_ATANH)
	(void)install_const_number("__NATIVE_ATANH__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_ATANH__", FP(0.0));
#endif

#if defined(HAVE_CBRT)
	(void)install_const_number("__NATIVE_CBRT__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_CBRT__", FP(0.0));
#endif

#if defined(HAVE_CEIL)
	(void)install_const_number("__NATIVE_CEIL__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_CEIL__", FP(0.0));
#endif

#if defined(HAVE_COPYSIGN)
	(void)install_const_number("__NATIVE_COPYSIGN__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_COPYSIGN__", FP(0.0));
#endif

#if defined(HAVE_ERF)
	(void)install_const_number("__NATIVE_ERF__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_ERF__", FP(0.0));
#endif

#if defined(HAVE_ERFC)
	(void)install_const_number("__NATIVE_ERFC__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_ERFC__", FP(0.0));
#endif

#if defined(HAVE_EXPM1)
	(void)install_const_number("__NATIVE_EXPM1__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_EXPM1__", FP(0.0));
#endif

#if defined(HAVE_FLOOR)
	(void)install_const_number("__NATIVE_FLOOR__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_FLOOR__", FP(0.0));
#endif

#if defined(HAVE_FMOD)
	(void)install_const_number("__NATIVE_FMOD__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_FMOD__", FP(0.0));
#endif

#if defined(HAVE_GAMMA)
	(void)install_const_number("__NATIVE_GAMMA__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_GAMMA__", FP(0.0));
#endif

#if defined(HAVE_GETGID)
	(void)install_const_number("__NATIVE_GETGID__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_GETGID__", FP(0.0));
#endif

#if defined(HAVE_GETPID)
	(void)install_const_number("__NATIVE_GETPID__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_GETPID__", FP(0.0));
#endif

#if defined(HAVE_GETPPID)
	(void)install_const_number("__NATIVE_GETPPID__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_GETPPID__", FP(0.0));
#endif

#if defined(HAVE_GETUID)
	(void)install_const_number("__NATIVE_GETUID__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_GETUID__", FP(0.0));
#endif

#if defined(HAVE_HYPOT)
	(void)install_const_number("__NATIVE_HYPOT__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_HYPOT__", FP(0.0));
#endif

#if defined(HAVE_ILOGB)
	(void)install_const_number("__NATIVE_ILOGB__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_ILOGB__", FP(0.0));
#endif

#if defined(HAVE_J0)
	(void)install_const_number("__NATIVE_J0__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_J0__", FP(0.0));
#endif

#if defined(HAVE_J1)
	(void)install_const_number("__NATIVE_J1__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_J1__", FP(0.0));
#endif

#if defined(HAVE_JN)
	(void)install_const_number("__NATIVE_JN__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_JN__", FP(0.0));
#endif

#if defined(HAVE_LDEXP)
	(void)install_const_number("__NATIVE_LDEXP__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_LDEXP__", FP(0.0));
#endif

#if defined(HAVE_LGAMMA)
	(void)install_const_number("__NATIVE_LGAMMA__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_LGAMMA__", FP(0.0));
#endif

#if defined(HAVE_LOG1P)
	(void)install_const_number("__NATIVE_LOG1P__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_LOG1P__", FP(0.0));
#endif

#if defined(HAVE_NEAREST)
	(void)install_const_number("__NATIVE_NEAREST__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_NEAREST__", FP(0.0));
#endif

#if defined(HAVE_NEXTAFTER)
	(void)install_const_number("__NATIVE_NEXTAFTER__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_NEXTAFTER__", FP(0.0));
#endif

#if defined(HAVE_REMAINDER)
	(void)install_const_number("__NATIVE_REMAINDER__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_REMAINDER__", FP(0.0));
#endif

#if defined(HAVE_RINT)
	(void)install_const_number("__NATIVE_RINT__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_RINT__", FP(0.0));
#endif

#if defined(HAVE_RSQRT)
	(void)install_const_number("__NATIVE_RSQRT__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_RSQRT__", FP(0.0));
#endif

#if defined(HAVE_SCALB)
	(void)install_const_number("__NATIVE_SCALB__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_SCALB__", FP(0.0));
#endif

#if defined(HAVE_SIGNIFICAND)
	(void)install_const_number("__NATIVE_SIGNIFICAND__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_SIGNIFICAND__", FP(0.0));
#endif

#if defined(HAVE_SNPRINTF)
	(void)install_const_number("__NATIVE_SNPRINTF__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_SNPRINTF__", FP(0.0));
#endif

#if defined(HAVE_STRFTIME)
	(void)install_const_number("__NATIVE_STRFTIME__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_STRFTIME__", FP(0.0));
#endif

#if defined(HAVE_STRTOLD)
	(void)install_const_number("__NATIVE_STRTOLD__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_STRTOLD__", FP(0.0));
#endif

#if defined(HAVE_TRUNC)
	(void)install_const_number("__NATIVE_TRUNC__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_TRUNC__", FP(0.0));
#endif

#if defined(HAVE_Y0)
	(void)install_const_number("__NATIVE_Y0__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_Y0__", FP(0.0));
#endif

#if defined(HAVE_Y1)
	(void)install_const_number("__NATIVE_Y1__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_Y1__", FP(0.0));
#endif

#if defined(HAVE_YN)
	(void)install_const_number("__NATIVE_YN__", FP(1.0));
#else
	(void)install_const_number("__NATIVE_YN__", FP(0.0));
#endif

	(void)install_const_string("__PACKAGE_BUGREPORT__",	PACKAGE_BUGREPORT);
	(void)install_const_string("__PACKAGE_DATE__",		PACKAGE_DATE);
	(void)install_const_string("__PACKAGE_NAME__",		PACKAGE_NAME);
	(void)install_const_string("__PACKAGE_STRING__",	PACKAGE_STRING);
	(void)install_const_string("__PACKAGE_VERSION__",	PACKAGE_VERSION);

	/* Record the initialization file directories and names for
	   use in the language-changing procedures */

	(void)install_const_string("__HOCRC__",		hocrc);
	(void)install_const_string("__SYSHOCDIR__",	syshocdir);
	(void)install_const_string("__SYSHOCHLPBASE__",	syshochlpbase);
	(void)install_const_string("__SYSHOCHLP__",	syshochlp);
	(void)install_const_string("__SYSHOCRCBASE__",	syshocrcbase);
	(void)install_const_string("__SYSHOCRC__",	syshocrc);
	(void)install_const_string("__SYSHOCXLTBASE__",	syshocxltbase);
	(void)install_const_string("__SYSHOCXLT__",	syshocxlt);

	{
		const char *p1;
		const char *p2;
		const char *p3;
		const char *p4;
		(void)install_const_string("__SYSHOCPATH__",
					   p1 = concat5((p2 = concat2(syshocdir, "/site")),
							elementsep,
							(p3 = concat2((p4 = parentdir(syshocdir)), "/site")),
							elementsep,
							syshocdir));
		efree((void *)p1);
		efree((void *)p2);
		efree((void *)p3);
		efree((void *)p4);
	}

	if (getenv(HOCPATH) == (const char *)NULL) /* then supply HOCPATH=".:" */
		(void)Putenv(HOCPATH, concat2(".", elementsep));

#if defined(HAVE_GETGID)
	(void)update_const_number("__GID__", (fp_t)getgid());
#else
	(void)update_const_number("__GID__", FP(0.0));
#endif

#if defined(HAVE_GETPID)
	(void)update_const_number("__PID__", (fp_t)getpid());
#else
	(void)update_const_number("__PID__", FP(0.0));
#endif

#if defined(HAVE_GETPPID)
	(void)update_const_number("__PPID__", (fp_t)getppid());
#else
	(void)update_const_number("__PPID__", FP(0.0));
#endif

#if defined(HAVE_GETUID)
	(void)update_const_number("__UID__", (fp_t)getuid());
#else
	(void)update_const_number("__UID__", FP(0.0));
#endif

}

void
intcatch(int dummy)	/* catch interrupts */
{
	execerror("interrupt", (const char *)NULL);
}

int
main(int argc, char * argv[])	/* hoc7 */
{
	static int first = 1;

	init_limits();			/* this MUST be first! */

#if YYDEBUG
	yydebug = 3;
#endif
	progname = argv[0];
#if 0
	prog = (Inst *)egrow((Inst *)prog, &max_prog, sizeof(prog[0]));
#else
#if 0
	max_prog = 32767;
#else
	max_prog = 8 * 1024 * 1024;
#endif
	prog = (Inst *)emalloc(max_prog * sizeof(prog[0]));
	(void)update_const_number("__MAX_PROG__", (fp_t)max_prog);
#endif
	progp = progbase = &prog[0];

	init_fp_system();
	init_readline();
	init_locale();
	init_builtins();
	init_lineno();
	init_symbols();
	sanity_check();
	do_pre_args(&argc,(const char **)argv);
	do_init_files();
	do_post_args(&argc,argv);
	if (argc == 1) {	/* fake an argument list */
		static char stdhyphen[] = "-";
		static char *stdinonly[] = { stdhyphen, (char *)NULL };

		gargv = stdinonly;
		gargc = 1;
	} else if (first) {	/* for interrupts */
		first = 0;
		gargv = argv+1;
		gargc = argc-1;
	}
	while (moreinput())
		run();
	(void)signal(SIGINT, SIG_IGN);
	return 0;
}

int
moreinput(void)
{
	const char *new_filename;

	if (gargc-- <= 0)
		return 0;
	if ((fin != (FILE*)NULL) && (fin != stdin))
	{
		(void)fclose(fin);
		fin = (FILE*)NULL;
	}
	infile = *gargv++;
	if (infile == (const char *)NULL) /* skip over holes from command-line options */
		return moreinput();
	else if (strcmp(infile, "-") == 0) {
		fin = stdin;
		new_filename = infile = (const char *)NULL;
#if defined(HAVE_GNU_READLINE)
		(void)dup2(irl_fd_stdin,fileno(stdin)); /* restore original stdin */
	} else if ((fin=Freopen(infile, "r", stdin, &new_filename)) == (FILE*)NULL) {
#else
	} else if ((fin=Fopen(infile, "r", &new_filename)) == (FILE*)NULL) {
#endif
		(void)fprintf(stderr,  msg_translate("%s: can't open %s\n"), progname, infile);
		efree((void *)new_filename);
		return moreinput();
	}
	set_filename((infile == (const char *)NULL) ? "/dev/stdin" : new_filename);
	efree((void *)new_filename);
	return 1;
}

void
run(void)	/* execute until EOF */
{
	Symbol *sp;
	(void)setjmp(begin);
	(void)signal(SIGINT, intcatch);
	(void)signal(SIGFPE, fpecatch);

#if defined(SIGXCPU)
	(void)signal(SIGXCPU, xcpucatch);
#endif

	sp = lookup("__CPU_LIMIT__");
	if (sp != (Symbol*)NULL)
		(void)CPULimit(sp->u.val);
	for (initcode(); yyparse(); initcode())
		execute(progbase);
}

void
set_filename(const char *filename)
{
	Symbol *s;
	char temp[sizeof("__FILE__") + sizeof("18446744073709551616" /* 2^64 */) + 2];

	infile_count++;
	SNPRINTF4(temp, sizeof(temp), "__FILE__[%02d]", infile_count);
	(void)install_const_string(temp,filename);

	s = lookup("__FILE__");
	if (s == (Symbol*)NULL)
	{
#if 0
		/* temporarily suppressed: see io.c:run3() header comments for why */
		(void)install_const_string("__FILE__",filename);
#else
		(void)install_string("__FILE__",filename);
#endif
	}
	else
		(void)set_string(s,filename);
	init_lineno();
}

static void
show(const char *text[])
{
	size_t k;

	for (k = 0; text[k] != (const char *)NULL; ++k)
		(void)fprintf(stderr,"%s", msg_translate(text[k]));
}

static void
usage(void)
{
	static const char *text[] =
	{
		"Usage:\n",
		"\t",
		"",
		"\t[ --author ] [ --? ] [ --copyright] [ --Dname ]\n",
		"\t\t[ --Dname=number ] [ --Dname=\"string\" ]\n",
		"\t\t[ --Dname=symbol ] [ --help ] [ --no-banner ]\n",
		"\t\t[ --no-cd ] [ --no-help-file ] [ --no-load ]\n",
		"\t\t[ --no-logfile ] [ --no-readline ] [ --no-save ]\n",
		"\t\t[ --no-site-file ] [ --no-translation-file ]\n",
		"\t\t[ --no-user-file ] [ --quick ] [ --secure ]\n",
		"\t\t[ --silent ] [ --Uname ] [ --version ]\n",
		"\t\tinput-file(s) [ -- ] more-input-file(s)\n\n",
		"Options may be prefixed with either one or two hyphens.\n",
		(const char *)NULL,
	};
	text[2] = progname;		/* cannot be done at compile time */
	show(text);
}

static void
usage_and_die(const char *bad_option)
{
	(void)fprintf(stderr, msg_translate("Unrecognized option: [%s]\n"), bad_option);
	usage();
	exit(EXIT_FAILURE);
}

static void
version_and_die(void)
{
	static const char *text[] =
	{
		"This is ", PACKAGE_NAME,
		" version ", PACKAGE_VERSION,
		" of ", PACKAGE_DATE, ".\n\n",
		"Report bugs to ", PACKAGE_BUGREPORT, "\n",
		(const char *)NULL,
	};
	show(text);
	exit(EXIT_SUCCESS);
}

void
warning(const char *s, const char *t)	/* print warning message */
{
	const char *current_filename;
	(void)fflush(stdout);		/* force out any buffered data */
	(void)fflush(stderr);

	s = msg_translate(s);		/* internationalize the output */
	t = msg_translate(t);

#if 1
	/* Use GNU and UNIX standard
		file:lineno:message
	format instead of old style
		program:message [in file] near line nnn */

	current_filename = get_string("__FILE__");

	(void)fprintf(stderr, "\n");	/* ensure that message starts on a new line! */
	(void)fprintf(stderr, "%s:%d:%s", current_filename, lineno, s);
	if (t != (const char *)NULL)
		(void)fprintf(stderr, " %s", t);
	(void)fprintf(stderr, "\n");

	if (logfile_enabled && (fplog != (FILE*)NULL))
	{
		(void)fprintf(fplog, "#-? %s:%d:%s", current_filename, lineno, s);
		if (t != (const char *)NULL)
			(void)fprintf(fplog, " %s", t);
		(void)fprintf(fplog, "\n");
	}
#else
	(void)fprintf(stderr, "%s: %s", progname, s);
	if (t)
		(void)fprintf(stderr, " %s", t);
	if (infile)
		(void)fprintf(stderr, " in %s", infile);
	(void)fprintf(stderr, " near line %d\n", lineno);
#endif

	while (this_c != '\n' && this_c != EOF)
		if((this_c = getc(fin), this_c) == '\n')	/* flush rest of input line */
			bump_lineno();
		else if (this_c == EOF && errno == EINTR) {
			clearerr(stdin);	/* ick! */
			errno = 0;
		}
	(void)fflush(stderr);
}

void
yyerror(YYCONST char * s)	/* report compile-time error */
{
/*rob
	warning(s, (const char *)NULL);
	longjmp(begin, 0);
rob*/
	execerror(s, (const char *)NULL);
}

Symbol *
yygetid(void)		/* get identifier, installing it in the symbol table if necessary */
{
	Symbol *s;
	static char *sbuf = (char *)NULL;
	static size_t max_sbuf = 0;
	size_t n;

	if (max_sbuf == (size_t)0)	/* guarantee that buffer exists so NUL can be stored */
		sbuf = (char *)emalloc(max_sbuf = (size_t)8);

	this_c = getc(fin);
	n = 0;
	do {
		if ((n + 2) > max_sbuf)
		{
			sbuf = (char *)egrow((void *)sbuf, &max_sbuf, sizeof(sbuf[0]));
			(void)update_const_number("__MAX_NAME__", (fp_t)max_sbuf);
		}
		sbuf[n++] = this_c;
	} while ((this_c=getc(fin)) != EOF && IsIdMiddle(this_c));
	(void)ungetc(this_c, fin);
	sbuf[n] = '\0';
	if ((s=lookup(sbuf),s) == (Symbol*)NULL)
		s = install(sbuf, UNDEF, FP(0.0));

#if defined(DEBUG_YYLEX)
	(void)fprintf(stderr,"yygetid() -> VAR [%s]\n", sbuf);
#endif

	return (s);
}

const char *
yygetstr(void)
{	/* get a quoted string, assuming that the opening quote has just been read */
	static char *sbuf = (char *)NULL;
	static size_t max_sbuf = 0;
	int the_c;
	size_t n;

	if (max_sbuf == (size_t)0)	/* guarantee that buffer exists so NUL can be stored */
		sbuf = (char *)emalloc(max_sbuf = (size_t)16);

	for (n = 0; (the_c = getc(fin)) != QUOTATION_MARK; )
	{
		if (the_c == '\n' || the_c == EOF)
			execerror("missing quote", "");
		if ((n + 2) > max_sbuf)
		{
			sbuf = (char *)egrow((void *)sbuf, &max_sbuf, sizeof(sbuf[0]));
			(void)update_const_number("__MAX_STRING__", (fp_t)max_sbuf);
		}
		sbuf[n++] = backslash(the_c);
	}
	sbuf[n] = '\0';

	return((const char *)&sbuf[0]);
}

int
yylex(void)		/* hoc6 */
{
	while ((this_c=getc(fin)) == ' ' || this_c == '\t')
		;
	if (this_c == EOF)
		return 0;
	if (this_c == '\\') {
		this_c = getc(fin);
		if (this_c == '\n') {
			bump_lineno();
			return yylex();
		}
	}
	if (this_c == '#') {		/* comment */
		while ((this_c=getc(fin)) != '\n' && this_c != EOF)
			;
		if (this_c == '\n')
			bump_lineno();
		return this_c;
	}
	if (this_c == '.' || isdigit(this_c)) {	/* number */
		fp_t d;
		(void)ungetc(this_c, fin);
		(void)fscanf(fin, "%lf", &d); /* NB: this is really irl_fscanf(), which handles long double case correctly */
		yylval.sym = install("", NUMBER, d);
#if defined(DEBUG_YYLEX)
		(void)fprintf(stderr,"yylex() -> NUMBER [%lg]\n", d);
#endif
		return NUMBER;
	}
	if (IsIdStart(this_c)) {
		Symbol *s;
		(void)ungetc(this_c,fin);
		yylval.sym = s = yygetid();
		return s->type == UNDEF ? VAR : s->type;
	}
	if (this_c == '$') {	/* argument? */
		int n = 0;
		long type;
		this_c = getc(fin);
		if (this_c == '$')	/* $$n means string argument instead of numeric argument, $n */
			type = STRVAR;
		else
		{
			type = VAR;
			(void)ungetc(this_c, fin);
		}
		while (isdigit(this_c=getc(fin)))
			n = 10 * n + this_c - '0';
		(void)ungetc(this_c, fin);
		if (n == 0)
			execerror("strange $...", (const char *)NULL);
		yylval.narg = n;
#if defined(DEBUG_YYLEX)
		(void)fprintf(stderr,"yylex() -> %s [%d]\n", ((type == VAR) ? "ARG" : "STRARG"), n);
#endif
		return (type == VAR) ? ARG : STRARG;
	}
	if (this_c == QUOTATION_MARK) {	/* quoted string */
		const char *sbuf;
		sbuf = yygetstr();
#if 0
		/* Old ugly code that masquerades a string on top of a Symbol */
		yylval.sym = (Symbol *)emalloc(strlen(sbuf)+1);
		strcpy((char *)yylval.sym, sbuf);
#else
		/* New code to generate a real Symbol instead */
#if 0
		yylval.sym = (Symbol *)emalloc(sizeof(Symbol));
		yylval.sym->name = (const char *)NULL;
		yylval.sym->type = STRING;
		yylval.sym->u.str = dupstr(sbuf);
		make_immutable(yylval.sym);
		yylval.sym->next = (Symbol*)NULL;
#else
		yylval.sym = install_const_string("", sbuf);
#endif
#endif
#if defined(DEBUG_YYLEX)
		(void)fprintf(stderr,"yylex() -> STRING [%s]\n", sbuf);
#endif
		return STRING;
	}
	switch (this_c) {
	case '^':	return TO_POWER;
	case ':':	return follow('=', CONSTEQ, ':');
	case '+':	return follow('+', INC, follow('=', ADDEQ, '+'));
	case '-':	return follow('-', DEC, follow('=', SUBEQ, '-'));
	case '*':	return follow('=', MULEQ, follow('*', TO_POWER, '*'));
	case '/':	return follow('=', DIVEQ, '/');
	case '%':	return follow('=', MODEQ, '%');
	case '>':	return follow('=', GE, GT);
	case '<':	{
				if (follow('=', LE, LT) == LE)
					return (LE);
				else if (follow('>', LTGT, LT) == LTGT)
					return (LTGT);
				else
					return (LT);
			}
	case '=':	return follow('=', EQ, '=');
	case '!':	return follow('=', NE, NOT);
	case '|':	return follow('|', OR, '|');
	case '&':	return follow('&', AND, '&');
	case '\n':	bump_lineno(); return '\n';
	default:	return this_c;
	}
}
static YYCONST yytabelem yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
	};
# define YYNPROD 184
# define YYLAST 1916
static YYCONST yytabelem yyact[]={

   123,   352,    47,    74,   171,     6,    73,   231,    68,    91,
   232,    71,    69,   361,    70,    41,    72,   155,    43,   221,
    42,    47,    47,    47,   156,   157,   158,   159,   160,   161,
   154,    73,   188,   233,   235,   234,    71,   120,   353,   231,
   310,    72,    47,   243,   271,   270,   241,   242,   239,   240,
   264,   265,   238,   237,   236,   244,   246,   261,   262,   263,
   247,   248,   245,   249,   250,   251,   252,   259,   256,   257,
   266,   267,   268,   269,   258,   253,   254,   255,   260,    94,
    10,   342,   107,   302,   338,    95,    96,    47,   337,   114,
   219,   338,   220,   363,   336,   335,   319,   318,    26,    47,
    47,   317,   316,   315,   314,   313,   311,   309,    47,    47,
   294,   192,   275,   301,   300,   230,   218,   191,   190,   170,
   169,    47,   168,   167,   166,   165,   164,    68,    91,    11,
    91,    68,   163,   162,   148,   147,    47,   146,    98,   145,
   144,   227,   143,   142,   141,   140,    47,    47,    47,    47,
    91,    68,   139,   223,   224,   138,   137,   284,   286,   287,
   288,   289,   290,   134,   133,   132,    93,    47,    47,    47,
    47,    47,    47,    47,     3,   273,   272,     2,   124,   125,
    97,    61,    62,    63,    64,    65,    88,    92,     1,    47,
    47,    85,    25,     5,    68,    91,    68,    91,   122,    24,
     4,    23,   131,    68,    91,    68,    91,   136,   135,   128,
     0,     0,     0,     0,     0,     0,     0,     0,    91,    47,
    47,    47,     0,     0,     0,     0,     0,     0,     0,    68,
    91,    47,    27,    51,    20,    14,     0,    48,    49,    50,
     0,    28,    19,    18,     0,   172,    29,    30,    34,    35,
    36,    31,    32,    33,    52,    53,    37,    38,    54,    21,
    22,    55,    56,    57,    15,    58,    40,    39,    59,    60,
    16,    17,     0,   189,     0,     0,    86,     0,     0,    91,
    91,    91,    91,     0,     0,     0,    74,     0,     0,    44,
    45,    46,     0,     0,     0,     0,    91,    91,    91,    91,
    91,     0,     0,     0,    68,    91,    68,    91,    68,    91,
    47,    74,    47,   226,   312,   339,     0,   341,   109,   110,
   111,   112,   113,   108,    47,   115,   116,   117,   118,   119,
   340,     0,    47,     0,     0,     0,    47,    47,   130,    47,
     7,   348,   349,   354,     0,    91,    91,     0,    73,     0,
     0,    68,    91,    71,    69,     0,    70,   121,    72,   126,
     0,   126,    47,     0,    47,     0,   367,   364,   368,   366,
     0,     0,     0,   360,   100,   101,   102,   103,   104,    99,
   150,   151,   152,   153,     0,     0,     0,     0,     0,     0,
     0,     0,   105,   106,     0,     0,    73,     0,     0,     0,
   365,    71,    69,     0,    70,     0,    72,     0,   173,   174,
   175,   176,   177,   178,   179,   180,   181,   182,   183,   184,
   185,   186,   187,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   193,   195,   197,
   198,   199,   200,   201,     0,     0,   202,   204,   206,   207,
   208,   209,   210,   211,   212,   213,   214,   215,   216,     0,
    10,     0,     0,   229,     0,     8,     0,     0,     0,     0,
     0,   222,   222,   222,   228,     0,     0,     0,     0,     0,
   274,     0,   276,   277,   127,   129,   127,     0,     0,     0,
    41,     0,     0,    43,    51,    42,   285,     0,     0,     0,
     0,   291,   292,   293,     0,   149,     0,    87,     0,    11,
     0,     0,     0,     0,     0,    52,    53,     0,     0,    54,
     0,     0,    55,    56,    57,    84,    58,     0,     0,    59,
    60,     0,    17,     0,     0,     0,    73,     0,     0,     0,
     0,    71,    69,     0,    70,     0,    72,     0,     0,     0,
   149,     0,     0,     0,     0,     0,     0,   303,   305,   307,
     0,     0,   194,   196,     0,    10,     0,     0,     0,   303,
     0,   203,   205,    26,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   217,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    41,     0,     0,    43,     0,
    42,     0,     0,     0,     0,     0,     0,     0,     0,   278,
   279,   280,   281,     0,    11,    82,    75,    76,    77,    79,
    80,    81,    78,     0,     0,     0,     0,     0,    74,     0,
   295,   296,   297,   298,   299,   194,   196,     0,     0,     0,
     0,    41,     0,     0,    43,     0,    42,     0,   228,   222,
   228,     0,   203,   205,     0,     0,     0,     0,     0,     0,
     0,   343,    83,    82,    75,    76,    77,    79,    80,    81,
    78,   346,     0,   347,   228,   228,    74,   350,    26,     0,
   225,     0,   304,   306,   308,    73,     0,     0,    86,   283,
    71,    69,   222,    70,   304,    72,     0,     0,   362,     0,
   228,     0,   228,     0,     0,     0,     9,    27,    51,    20,
    14,     0,    48,    49,    50,     0,    28,    19,    18,    12,
    13,    29,    30,    34,    35,    36,    31,    32,    33,    52,
    53,    37,    38,    54,    21,    22,    55,    56,    57,    15,
    58,    40,    39,    59,    60,    16,    17,    10,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    44,    45,    46,     0,     0,     0,
     0,     0,     0,     0,    73,     0,     0,    86,     0,    71,
    69,     0,    70,     0,    72,     0,     0,   344,     0,     0,
     0,     0,     0,    73,     0,   345,    11,     0,    71,    69,
   359,    70,   351,    72,    75,    76,    77,    79,    80,    81,
    78,     0,    27,    51,    20,    14,    74,    48,    49,    50,
     0,    28,    19,    18,     0,     0,    29,    30,    34,    35,
    36,    31,    32,    33,    52,    53,    37,    38,    54,    21,
    22,    55,    56,    57,    15,    58,    40,    39,    59,    60,
    16,    17,     0,     0,     0,     0,     0,     0,    27,    51,
     0,    14,     0,     0,     0,     0,     0,    28,     0,    44,
    45,    46,    29,    30,    34,    35,    36,    31,    32,    33,
    52,    53,    37,    38,    54,     0,     0,    55,    56,    57,
    15,    58,    40,    39,    59,    60,    16,    17,     0,     0,
     0,     0,     0,     0,    73,    66,    51,    86,    67,    71,
    69,     0,    70,     0,    72,    44,    45,    46,     0,    87,
     0,     0,     0,     0,     0,     0,     0,    52,    53,     0,
     0,    54,     0,     0,    55,    56,    57,    84,    58,     0,
    73,    59,    60,     0,    17,    71,    69,   322,    70,     0,
    72,    83,    82,    75,    76,    77,    79,    80,    81,    78,
     0,     0,    73,     0,     0,    74,   358,    71,    69,     0,
    70,     0,    72,     0,     0,     0,     0,    73,     0,     0,
     0,   355,    71,    69,     0,    70,     0,    72,     0,     0,
     0,     0,     0,     0,    66,    51,    73,    67,     0,     0,
   329,    71,    69,     0,    70,     0,    72,     0,    87,     0,
     0,     0,     0,     0,     0,     0,    52,    53,     0,     0,
    54,     0,     0,    55,    56,    57,    84,    58,     0,    73,
    59,    60,     0,    17,    71,    69,     0,    70,     0,    72,
    83,    82,    75,    76,    77,    79,    80,    81,    78,     0,
     0,     0,     0,     0,    74,     0,     0,     0,     0,    83,
    82,    75,    76,    77,    79,    80,    81,    78,     0,     0,
    73,     0,     0,    74,   328,    71,    69,     0,    70,     0,
    72,     0,     0,     0,     0,    73,     0,     0,     0,   327,
    71,    69,     0,    70,     0,    72,     0,     0,     0,     0,
    73,     0,     0,     0,   321,    71,    69,     0,    70,     0,
    72,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    66,    51,    73,    67,     0,     0,
   320,    71,    69,     0,    70,     0,    72,     0,    87,     0,
     0,     0,     0,     0,     0,     0,    52,    53,     0,     0,
    54,     0,     0,    55,    56,    57,    84,    58,     0,     0,
    59,    60,     0,    17,     0,     0,    10,     0,     0,     0,
    83,    82,    75,    76,    77,    79,    80,    81,    78,     0,
     0,     0,     0,     0,    74,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    86,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    83,    82,    75,    76,
    77,    79,    80,    81,    78,    11,     0,     0,     0,     0,
    74,     0,     0,     0,     0,     0,     0,     0,    83,    82,
    75,    76,    77,    79,    80,    81,    78,    86,   357,     0,
     0,     0,    74,    83,    82,    75,    76,    77,    79,    80,
    81,    78,     0,     0,     0,     0,     0,    74,     0,     0,
     0,     0,    83,    82,    75,    76,    77,    79,    80,    81,
    78,     0,     0,     0,     0,     0,    74,    86,   356,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,    83,    82,    75,    76,    77,
    79,    80,    81,    78,     0,     0,     0,     0,     0,    74,
     0,     0,     0,     0,     0,     0,     0,    86,     0,     0,
     0,   334,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    83,    82,    75,    76,
    77,    79,    80,    81,    78,     0,     0,     0,     0,     0,
    74,    83,    82,    75,    76,    77,    79,    80,    81,    78,
    86,   333,     0,     0,     0,    74,    83,    82,    75,    76,
    77,    79,    80,    81,    78,     0,     0,     0,     0,     0,
    74,     0,     0,     0,    86,     0,     0,     0,   332,     0,
     0,     0,    83,    82,    75,    76,    77,    79,    80,    81,
    78,     0,     0,     0,     0,     0,    74,     0,    86,     0,
     0,     0,   331,    89,    51,     0,    90,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,    87,     0,     0,
     0,     0,    86,   330,     0,    52,    53,     0,     0,    54,
     0,     0,    55,    56,    57,    84,    58,     0,     0,    59,
    60,     0,    17,     0,    89,    51,     0,    90,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    87,     0,
     0,     0,    86,   326,     0,     0,    52,    53,     0,     0,
    54,     0,     0,    55,    56,    57,    84,    58,     0,     0,
    59,    60,     0,    17,    89,    51,     0,    90,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    87,     0,
     0,     0,    86,   325,     0,     0,    52,    53,     0,     0,
    54,     0,     0,    55,    56,    57,    84,    58,     0,     0,
    59,    60,     0,    17,    89,    51,     0,    90,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,    87,     0,
     0,     0,    86,   324,     0,     0,    52,    53,     0,     0,
    54,     0,     0,    55,    56,    57,    84,    58,     0,     0,
    59,    60,     0,    17,     0,     0,     0,    89,    51,     0,
    90,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    87,    86,     0,     0,     0,   323,     0,     0,    52,
    53,    89,    51,    54,    90,     0,    55,    56,    57,    84,
    58,     0,     0,    59,    60,    87,    17,     0,     0,     0,
     0,     0,     0,    52,    53,    89,    51,    54,    90,     0,
    55,    56,    57,    84,    58,    86,   282,    59,    60,    87,
    17,     0,     0,     0,     0,     0,     0,    52,    53,    89,
    51,    54,    90,     0,    55,    56,    57,    84,    58,    86,
     0,    59,    60,    87,    17,     0,     0,     0,     0,     0,
     0,    52,    53,     0,     0,    54,     0,     0,    55,    56,
    57,    84,    58,     0,     0,    59,    60,     0,    17,    89,
    51,     0,    90,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    87,     0,     0,     0,     0,     0,     0,
     0,    52,    53,     0,     0,    54,     0,     0,    55,    56,
    57,    84,    58,     0,     0,    59,    60,     0,    17,    89,
    51,     0,    90,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    87,     0,     0,     0,     0,     0,     0,
     0,    52,    53,     0,     0,    54,     0,     0,    55,    56,
    57,    84,    58,     0,     0,    59,    60,     0,    17,    89,
    51,     0,    90,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    87,     0,     0,     0,     0,     0,     0,
     0,    52,    53,     0,     0,    54,     0,     0,    55,    56,
    57,    84,    58,     0,     0,    59,    60,     0,    17,    89,
    51,     0,    90,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,    87,     0,     0,     0,     0,     0,     0,
     0,    52,    53,     0,     0,    54,     0,     0,    55,    56,
    57,    84,    58,     0,     0,    59,    60,     0,    17,     0,
     0,     0,    89,    51,     0,    90,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,    87,     0,     0,     0,
     0,     0,     0,     0,    52,    53,    89,    51,    54,    90,
     0,    55,    56,    57,    84,    58,     0,     0,    59,    60,
    87,    17,     0,     0,     0,     0,     0,     0,    52,    53,
     0,     0,    54,     0,     0,    55,    56,    57,    84,    58,
     0,     0,    59,    60,     0,    17 };
static YYCONST yytabelem yypact[]={

-10000000,   450,-10000000,    70,    70,    70,    70,   737,  1156,    70,
-10000000,-10000000,  -181,  -181,    77,    21,    28,   -24,   601,-10000000,
   601,   601,   601,   125,   124,   123,-10000000,-10000000,-10000000,   116,
   115,   112,   105,   104,   103,   102,   100,    99,    97,    95,
    94,   601,   601,   601,   601,  -230,  -243,  -281,-10000000,-10000000,
-10000000,-10000000,    93,    92,    86,    85,    84,    83,    82,    80,
    79,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,   -57,-10000000,   601,
   601,   601,   601,   601,   601,   601,   601,   601,   601,   601,
   601,   601,   601,   601,   -29,-10000000,   601,    78,-10000000,-10000000,
   -57,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,   601,   601,
   601,   601,   601,   601,   601,-10000000,-10000000,   601,   601,   601,
   601,   601,   601,   601,   601,   601,   601,   601,   601,   601,
   601,   992,-10000000,  -281,    76,    46,   867,  1619,    48,  1619,
   867,    46,   601,   601,   601,   555,    75,  -250,  -225,  -216,
  -216,   601,    71,   601,   601,   601,   601,   601,   601,  1595,
   648,  -314,  -314,  -314,-10000000,-10000000,   236,   236,   236,   236,
   236,   236,   601,   601,   601,    69,   601,   601,   601,   601,
   601,   601,   601,    -6,    -6,  -314,  -314,  -314,  -314,   -31,
   -31,   -31,   -31,   -31,   -31,   -31,   499,   311,   601,   601,
  -282,    74,    73,   867,  1619,   867,  1619,   992,   992,   992,
   992,   992,   867,  1619,   867,  1619,   992,   992,   992,   992,
   992,   992,   992,   992,   992,   992,   992,  1619,   601,   601,
   601,    66,   992,   -19,    65,-10000000,-10000000,-10000000,   867,  1619,
   601,    64,    63,    62,    61,    60,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,    56,    55,  1089,-10000000,  1063,   903,  1552,  1512,
  1472,  1432,-10000000,-10000000,-10000000,   -57,-10000000,-10000000,-10000000,-10000000,
-10000000,  1048,  1033,   959,-10000000,  1392,  1368,  1344,  1320,  1277,
    54,    53,    47,   867,  1619,   867,  1619,   867,  1619,   -25,
   601,   -25,    40,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,-10000000,   601,   601,-10000000,-10000000,-10000000,-10000000,-10000000,-10000000,
-10000000,   601,   601,-10000000,   601,   -25,   -25,-10000000,   601,-10000000,
   -21,-10000000,-10000000,   940,  1237,  1197,   925,   756,-10000000,-10000000,
   867,  1619,-10000000,   601,  -252,-10000000,-10000000,-10000000,-10000000,   601,
    52,   -25,   359,   -25,-10000000,-10000000,-10000000,-10000000,-10000000 };
static YYCONST yytabelem yypgo[]={

     0,   338,     5,   198,   179,   209,   208,    19,   201,   199,
   192,   178,     1,   191,   463,     0,    35,    34,   166,    83,
   188,   177,   174,   117,   111 };
static YYCONST yytabelem yyr1[]={

     0,    20,    20,    20,    20,    20,    20,    20,    20,    20,
    21,    21,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
     3,     3,    13,    13,    13,    13,    13,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     7,     8,     9,    10,    11,    12,    16,    16,    16,    16,
    16,    16,    16,    16,    16,    16,    16,    16,    16,    16,
    16,    16,    16,    16,    16,    16,    16,    16,    16,    16,
    16,    17,    17,    17,    17,    17,    17,    17,    17,    17,
    17,    17,     6,     6,     6,    15,    15,    15,    15,    15,
    15,    15,    15,    15,    15,    15,    15,    15,    15,    15,
    14,    14,    14,    14,    14,    14,    14,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
     1,     1,     1,     1,     1,     4,     4,     4,     4,     5,
     5,     5,    23,    22,    24,    22,    18,    18,    18,    19,
    19,    19,    19,    19 };
static YYCONST yytabelem yyr2[]={

     0,     0,     4,     6,     7,     7,     7,     7,     7,     7,
     2,     2,     7,     7,     7,     7,     7,     7,     7,     7,
     7,     7,     7,     7,     7,     7,     7,     7,     7,     7,
     7,     7,     7,     7,     7,     7,     7,     3,     3,     3,
     5,    11,     5,     5,     5,    13,    21,    13,    19,     7,
     3,     3,     3,     3,     1,     1,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     1,     4,     4,     3,     3,     3,     2,     7,
     9,     9,     9,     9,     7,     9,    13,    13,     9,    17,
     2,     5,     5,     5,     5,     5,     5,     3,     3,     3,
     2,    11,     9,     9,     9,     9,     9,     9,     9,     7,
     9,    13,    13,     9,     9,     9,     7,     7,     7,     7,
     7,     7,     7,     5,     5,     7,     7,     7,     7,     7,
     7,     7,     7,     7,     5,     5,     5,     5,     5,     7,
     7,     7,     7,     7,     7,     3,     3,     7,     7,     3,
     7,     7,     1,    13,     1,    13,     2,     2,     2,     1,
     3,     3,     7,     7 };
static YYCONST yytabelem yychk[]={

-10000000,   -20,   -21,   -22,    -3,   -13,    -2,    -1,   -14,   256,
    10,    59,   269,   270,   260,   289,   295,   296,   268,   267,
   259,   284,   285,    -8,    -9,   -10,   123,   257,   266,   271,
   272,   276,   277,   278,   273,   274,   275,   281,   282,   292,
   291,    40,    45,    43,   314,   315,   316,   -15,   262,   263,
   264,   258,   279,   280,   283,   286,   287,   288,   290,   293,
   294,   -21,   -21,   -21,   -21,   -21,   257,   260,   -15,    43,
    45,    42,    47,    37,   317,   305,   306,   307,   311,   308,
   309,   310,   304,   303,   289,   -13,    40,   271,   -21,   257,
   260,   -15,   -21,   -18,   260,   266,   267,   -18,    61,   302,
   297,   298,   299,   300,   301,   315,   316,    61,   302,   297,
   298,   299,   300,   301,    61,   297,   298,   299,   300,   301,
    61,    -1,    -3,   -15,   -11,    -4,    -1,   -14,    -5,   -14,
    -1,    -4,    40,    40,    40,    -6,   -11,    40,    40,    40,
    40,    40,    40,    40,    40,    40,    40,    40,    40,   -14,
    -1,    -1,    -1,    -1,   260,   260,   305,   306,   307,   308,
   309,   310,    40,    40,    40,    40,    40,    40,    40,    40,
    40,    61,   302,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    61,   302,
    40,   -23,   -24,    -1,   -14,    -1,   -14,    -1,    -1,    -1,
    -1,    -1,    -1,   -14,    -1,   -14,    -1,    -1,    -1,    -1,
    -1,    -1,    -1,    -1,    -1,    -1,    -1,   -14,    40,    44,
    44,    -7,    -1,    -7,    -7,   125,   -21,    -2,    -1,   -14,
    40,   289,   260,   258,   -16,   -17,   270,   269,   268,   264,
   265,   262,   263,   259,   271,   278,   272,   276,   277,   279,
   280,   281,   282,   291,   292,   293,   284,   285,   290,   283,
   294,   273,   274,   275,   266,   267,   286,   287,   288,   289,
   261,   260,   -16,   -17,    -1,    41,    -1,    -1,   -14,   -14,
   -14,   -14,    41,    41,   -15,   260,   -15,   -15,   -15,   -15,
   -15,    -1,    -1,    -1,    41,   -14,   -14,   -14,   -14,   -14,
    40,    40,   -19,    -1,   -14,    -1,   -14,    -1,   -14,    41,
    59,    41,   -19,    41,    41,    41,    41,    41,    41,    41,
    41,    41,    44,    44,    41,    41,    41,    41,    41,    41,
    41,    44,    44,    41,    44,    41,    41,    41,    44,    -2,
    -7,    -2,    41,    -1,   -14,   -14,    -1,    -1,    -2,    -2,
    -1,   -14,   -12,    59,   -12,    41,    41,    41,    41,    44,
    -7,   265,    -1,    41,    -2,    41,    -2,   -12,   -12 };
static YYCONST yytabelem yydef[]={

     1,    -2,     2,     0,   120,    98,     0,     0,     0,     0,
    10,    11,     0,     0,   118,    96,   119,    97,    39,    54,
     0,     0,     0,     0,     0,     0,    92,   117,    54,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,   110,    51,    52,
    53,    95,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     3,     4,     5,     6,     7,   111,   112,   113,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,    96,    98,     0,     0,     8,   114,
   115,   116,     9,   172,   176,   177,   178,   174,     0,     0,
     0,     0,     0,     0,     0,   157,   158,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,    40,   120,     0,     0,    42,   165,   166,    43,   169,
     0,    44,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,   143,   144,   154,   155,   156,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,   137,   138,   139,   140,   141,   142,   145,
   146,   147,   148,   149,   150,   151,   152,   153,     0,     0,
     0,     0,     0,    12,    35,    13,    36,    14,    15,    16,
    17,    18,    19,    32,    20,    33,    21,    22,    23,    24,
    25,    26,    27,    28,    29,    30,    31,    34,   179,     0,
     0,     0,    50,     0,     0,    49,    93,    94,    37,    38,
   179,     0,     0,     0,     0,     0,    56,    57,    58,    59,
    60,    61,    62,    63,    64,    65,    66,    67,    68,    69,
    70,    71,    72,    73,    74,    75,    76,    77,    78,    79,
    80,    81,    82,    83,    84,    85,    86,    87,    88,    89,
    90,    91,     0,     0,     0,   129,     0,     0,     0,     0,
     0,     0,    99,   136,   159,     0,   160,   161,   162,   163,
   164,     0,     0,     0,   104,     0,     0,     0,     0,     0,
     0,     0,     0,   180,   181,   167,   168,   170,   171,     0,
     0,     0,     0,   103,   122,   123,   124,   125,   126,   127,
   128,   130,     0,     0,   133,   134,   135,   100,   101,   102,
   105,     0,     0,   108,     0,     0,     0,    41,     0,    55,
     0,    55,   121,     0,     0,     0,     0,     0,   173,   175,
   182,   183,    45,     0,    47,   131,   132,   106,   107,     0,
     0,     0,     0,     0,    55,   109,    55,    48,    46 };
typedef struct
#ifdef __cplusplus
	yytoktype
#endif
{ char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"NUMBER",	257,
	"STRING",	258,
	"PRINT",	259,
	"VAR",	260,
	"UNDEF",	261,
	"WHILE",	262,
	"FOR",	263,
	"IF",	264,
	"ELSE",	265,
	"FUNCTION",	266,
	"PROCEDURE",	267,
	"RETURN",	268,
	"FUNC",	269,
	"PROC",	270,
	"READ",	271,
	"ABORT",	272,
	"BLTIN0",	273,
	"BLTIN1",	274,
	"BLTIN2",	275,
	"DEFINED",	276,
	"DELETE",	277,
	"HEX",	278,
	"HEXFP",	279,
	"HEXINT",	280,
	"INDEX",	281,
	"LENGTH",	282,
	"NUMTOSTR",	283,
	"PRINTF",	284,
	"PRINTLN",	285,
	"STRBLTIN0",	286,
	"STRBLTIN1",	287,
	"STRBLTIN2",	288,
	"STRVAR",	289,
	"STRFTIME",	290,
	"STRTONUM",	291,
	"STRTOSYMNUM",	292,
	"STRTOSYMSTR",	293,
	"SUBSTR",	294,
	"ARG",	295,
	"STRARG",	296,
	"=",	61,
	"ADDEQ",	297,
	"SUBEQ",	298,
	"MULEQ",	299,
	"DIVEQ",	300,
	"MODEQ",	301,
	"CONSTEQ",	302,
	"OR",	303,
	"AND",	304,
	"GT",	305,
	"GE",	306,
	"LT",	307,
	"LE",	308,
	"EQ",	309,
	"NE",	310,
	"LTGT",	311,
	"+",	43,
	"-",	45,
	"*",	42,
	"/",	47,
	"%",	37,
	"UNARYMINUS",	312,
	"UNARYPLUS",	313,
	"NOT",	314,
	"INC",	315,
	"DEC",	316,
	"TO_POWER",	317,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"list : /* empty */",
	"list : list eos",
	"list : list defn eos",
	"list : list asgn eos",
	"list : list strasgn eos",
	"list : list stmt eos",
	"list : list expr eos",
	"list : list strexpr eos",
	"list : list error eos",
	"eos : '\n'",
	"eos : ';'",
	"asgn : VAR '=' expr",
	"asgn : VAR CONSTEQ expr",
	"asgn : VAR ADDEQ expr",
	"asgn : VAR SUBEQ expr",
	"asgn : VAR MULEQ expr",
	"asgn : VAR DIVEQ expr",
	"asgn : VAR MODEQ expr",
	"asgn : STRVAR '=' expr",
	"asgn : STRVAR CONSTEQ expr",
	"asgn : STRVAR ADDEQ expr",
	"asgn : STRVAR SUBEQ expr",
	"asgn : STRVAR MULEQ expr",
	"asgn : STRVAR DIVEQ expr",
	"asgn : STRVAR MODEQ expr",
	"asgn : ARG '=' expr",
	"asgn : ARG ADDEQ expr",
	"asgn : ARG SUBEQ expr",
	"asgn : ARG MULEQ expr",
	"asgn : ARG DIVEQ expr",
	"asgn : ARG MODEQ expr",
	"strasgn : STRVAR '=' strexpr",
	"strasgn : STRVAR CONSTEQ strexpr",
	"strasgn : STRARG '=' strexpr",
	"strasgn : VAR '=' strexpr",
	"strasgn : VAR CONSTEQ strexpr",
	"stmt : expr",
	"stmt : strexpr",
	"stmt : RETURN",
	"stmt : RETURN expr",
	"stmt : PROCEDURE begin '(' arglist ')'",
	"stmt : PRINT prlist",
	"stmt : PRINTF prflist",
	"stmt : PRINTLN prlist",
	"stmt : while '(' cond ')' stmt end",
	"stmt : for '(' cond ';' cond ';' cond ')' stmt end",
	"stmt : if '(' cond ')' stmt end",
	"stmt : if '(' cond ')' stmt end ELSE stmt end",
	"stmt : '{' stmtlist '}'",
	"cond : expr",
	"while : WHILE",
	"for : FOR",
	"if : IF",
	"begin : /* empty */",
	"end : /* empty */",
	"keyword : PROC",
	"keyword : FUNC",
	"keyword : RETURN",
	"keyword : IF",
	"keyword : ELSE",
	"keyword : WHILE",
	"keyword : FOR",
	"keyword : PRINT",
	"keyword : READ",
	"keyword : HEX",
	"keyword : ABORT",
	"keyword : DEFINED",
	"keyword : DELETE",
	"keyword : HEXFP",
	"keyword : HEXINT",
	"keyword : INDEX",
	"keyword : LENGTH",
	"keyword : STRTONUM",
	"keyword : STRTOSYMNUM",
	"keyword : STRTOSYMSTR",
	"keyword : PRINTF",
	"keyword : PRINTLN",
	"keyword : STRFTIME",
	"keyword : NUMTOSTR",
	"keyword : SUBSTR",
	"othername : BLTIN0",
	"othername : BLTIN1",
	"othername : BLTIN2",
	"othername : FUNCTION",
	"othername : PROCEDURE",
	"othername : STRBLTIN0",
	"othername : STRBLTIN1",
	"othername : STRBLTIN2",
	"othername : STRVAR",
	"othername : UNDEF",
	"othername : VAR",
	"stmtlist : /* empty */",
	"stmtlist : stmtlist eos",
	"stmtlist : stmtlist stmt",
	"string : STRING",
	"string : STRVAR",
	"string : STRARG",
	"string : strasgn",
	"string : '(' strexpr ')'",
	"string : HEXFP '(' expr ')'",
	"string : HEXINT '(' expr ')'",
	"string : NUMTOSTR '(' expr ')'",
	"string : READ '(' STRVAR ')'",
	"string : STRBLTIN0 '(' ')'",
	"string : STRBLTIN1 '(' strexpr ')'",
	"string : STRBLTIN2 '(' strexpr ',' strexpr ')'",
	"string : STRFTIME '(' strexpr ',' expr ')'",
	"string : STRTOSYMSTR '(' strexpr ')'",
	"string : SUBSTR '(' strexpr ',' expr ',' expr ')'",
	"strexpr : string",
	"strexpr : expr NUMBER",
	"strexpr : expr VAR",
	"strexpr : expr string",
	"strexpr : strexpr NUMBER",
	"strexpr : strexpr VAR",
	"strexpr : strexpr string",
	"expr : NUMBER",
	"expr : VAR",
	"expr : ARG",
	"expr : asgn",
	"expr : FUNCTION begin '(' arglist ')'",
	"expr : READ '(' VAR ')'",
	"expr : ABORT '(' STRING ')'",
	"expr : DEFINED '(' keyword ')'",
	"expr : DEFINED '(' othername ')'",
	"expr : DELETE '(' keyword ')'",
	"expr : DELETE '(' othername ')'",
	"expr : HEX '(' expr ')'",
	"expr : BLTIN0 '(' ')'",
	"expr : BLTIN1 '(' expr ')'",
	"expr : BLTIN2 '(' expr ',' expr ')'",
	"expr : INDEX '(' strexpr ',' strexpr ')'",
	"expr : LENGTH '(' strexpr ')'",
	"expr : STRTOSYMNUM '(' strexpr ')'",
	"expr : STRTONUM '(' strexpr ')'",
	"expr : '(' expr ')'",
	"expr : expr '+' expr",
	"expr : expr '-' expr",
	"expr : expr '*' expr",
	"expr : expr '/' expr",
	"expr : expr '%' expr",
	"expr : expr TO_POWER expr",
	"expr : '-' expr",
	"expr : '+' expr",
	"expr : expr GT expr",
	"expr : expr GE expr",
	"expr : expr LT expr",
	"expr : expr LTGT expr",
	"expr : expr LE expr",
	"expr : expr EQ expr",
	"expr : expr NE expr",
	"expr : expr AND expr",
	"expr : expr OR expr",
	"expr : NOT expr",
	"expr : INC VAR",
	"expr : DEC VAR",
	"expr : VAR INC",
	"expr : VAR DEC",
	"expr : string GT string",
	"expr : string GE string",
	"expr : string LT string",
	"expr : string LE string",
	"expr : string EQ string",
	"expr : string NE string",
	"prlist : expr",
	"prlist : strexpr",
	"prlist : prlist ',' expr",
	"prlist : prlist ',' strexpr",
	"prflist : strexpr",
	"prflist : prflist ',' expr",
	"prflist : prflist ',' strexpr",
	"defn : FUNC procname",
	"defn : FUNC procname '(' ')' stmt",
	"defn : PROC procname",
	"defn : PROC procname '(' ')' stmt",
	"procname : VAR",
	"procname : FUNCTION",
	"procname : PROCEDURE",
	"arglist : /* empty */",
	"arglist : expr",
	"arglist : strexpr",
	"arglist : arglist ',' expr",
	"arglist : arglist ',' strexpr",
};
#endif /* YYDEBUG */
# line	1 "/usr/ccs/bin/yaccpar"
/*
 * Copyright (c) 1993 by Sun Microsystems, Inc.
 */

#pragma ident	"@(#)yaccpar	6.16	99/01/20 SMI"

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	return(0)
#define YYABORT		return(1)
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#define YYNEW(type)	malloc(sizeof(type) * yynewmax)
#define YYCOPY(to, from, type) \
	(type *) memcpy(to, (char *) from, yymaxdepth * sizeof (type))
#define YYENLARGE( from, type) \
	(type *) realloc((char *) from, yynewmax * sizeof(type))
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-10000000)

/*
** global variables used by the parser
*/
YYSTYPE *yypv;			/* top of value stack */
int *yyps;			/* top of state stack */

int yystate;			/* current state */
int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */
int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */



#ifdef YYNMBCHARS
#define YYLEX()		yycvtok(yylex())
/*
** yycvtok - return a token if i is a wchar_t value that exceeds 255.
**	If i<255, i itself is the token.  If i>255 but the neither 
**	of the 30th or 31st bit is on, i is already a token.
*/
#if defined(__STDC__) || defined(__cplusplus)
int yycvtok(int i)
#else
int yycvtok(i) int i;
#endif
{
	int first = 0;
	int last = YYNMBCHARS - 1;
	int mid;
	wchar_t j;

	if(i&0x60000000){/*Must convert to a token. */
		if( yymbchars[last].character < i ){
			return i;/*Giving up*/
		}
		while ((last>=first)&&(first>=0)) {/*Binary search loop*/
			mid = (first+last)/2;
			j = yymbchars[mid].character;
			if( j==i ){/*Found*/ 
				return yymbchars[mid].tvalue;
			}else if( j<i ){
				first = mid + 1;
			}else{
				last = mid -1;
			}
		}
		/*No entry in the table.*/
		return i;/* Giving up.*/
	}else{/* i is already a token. */
		return i;
	}
}
#else/*!YYNMBCHARS*/
#define YYLEX()		yylex()
#endif/*!YYNMBCHARS*/

/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
#if defined(__STDC__) || defined(__cplusplus)
int yyparse(void)
#else
int yyparse()
#endif
{
	register YYSTYPE *yypvt = 0;	/* top of value stack for $vars */

#if defined(__cplusplus) || defined(lint)
/*
	hacks to please C++ and lint - goto's inside
	switch should never be executed
*/
	static int __yaccpar_lint_hack__ = 0;
	switch (__yaccpar_lint_hack__)
	{
		case 1: goto yyerrlab;
		case 2: goto yynewstate;
	}
#endif

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

#if YYMAXDEPTH <= 0
	if (yymaxdepth <= 0)
	{
		if ((yymaxdepth = YYEXPAND(0)) <= 0)
		{
			yyerror("yacc initialization error");
			YYABORT;
		}
	}
#endif

	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */
	goto yystack;	/* moved from 6 lines above to here to please C++ */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			long yyps_index = (yy_ps - yys);
			long yypv_index = (yy_pv - yyv);
			long yypvt_index = (yypvt - yyv);
			int yynewmax;
#ifdef YYEXPAND
			yynewmax = YYEXPAND(yymaxdepth);
#else
			yynewmax = 2 * yymaxdepth;	/* double table size */
			if (yymaxdepth == YYMAXDEPTH)	/* first time growth */
			{
				char *newyys = (char *)YYNEW(int);
				char *newyyv = (char *)YYNEW(YYSTYPE);
				if (newyys != 0 && newyyv != 0)
				{
					yys = YYCOPY(newyys, yys, int);
					yyv = YYCOPY(newyyv, yyv, YYSTYPE);
				}
				else
					yynewmax = 0;	/* failed */
			}
			else				/* not first time */
			{
				yys = YYENLARGE(yys, int);
				yyv = YYENLARGE(yyv, YYSTYPE);
				if (yys == 0 || yyv == 0)
					yynewmax = 0;	/* failed */
			}
#endif
			if (yynewmax <= yymaxdepth)	/* tables not expanded */
			{
				yyerror( "yacc stack overflow" );
				YYABORT;
			}
			yymaxdepth = yynewmax;

			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			printf( "Received token " );
			if ( yychar == 0 )
				printf( "end-of-file\n" );
			else if ( yychar < 0 )
				printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = YYLEX() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				printf( "Received token " );
				if ( yychar == 0 )
					printf( "end-of-file\n" );
				else if ( yychar < 0 )
					printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register YYCONST int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
			skip_init:
				yynerrs++;
				/* FALLTHRU */
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					printf( "Error recovery discards " );
					if ( yychar == 0 )
						printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 4:
# line 191 "hoc.y"
{ CODE2(xpop, STOP); return 1; } break;
case 5:
# line 192 "hoc.y"
{ CODE2(xpop, STOP); return 1; } break;
case 6:
# line 193 "hoc.y"
{ CODE(STOP); return 1; } break;
case 7:
# line 194 "hoc.y"
{ CODE2(printtop, STOP); return 1; } break;
case 8:
# line 195 "hoc.y"
{ CODE2(printtopstring, STOP); return 1; } break;
case 9:
# line 196 "hoc.y"
{ yyerrok; } break;
case 12:
# line 203 "hoc.y"
{ CODE3(varpush,(Inst)yypvt[-2].sym,assign); yyval.inst=yypvt[-0].inst; } break;
case 13:
# line 204 "hoc.y"
{ CODE3(varpush,(Inst)yypvt[-2].sym,const_assign); yyval.inst=yypvt[-0].inst; } break;
case 14:
# line 205 "hoc.y"
{ CODE3(varpush,(Inst)yypvt[-2].sym,addeq); yyval.inst=yypvt[-0].inst; } break;
case 15:
# line 206 "hoc.y"
{ CODE3(varpush,(Inst)yypvt[-2].sym,subeq); yyval.inst=yypvt[-0].inst; } break;
case 16:
# line 207 "hoc.y"
{ CODE3(varpush,(Inst)yypvt[-2].sym,muleq); yyval.inst=yypvt[-0].inst; } break;
case 17:
# line 208 "hoc.y"
{ CODE3(varpush,(Inst)yypvt[-2].sym,diveq); yyval.inst=yypvt[-0].inst; } break;
case 18:
# line 209 "hoc.y"
{ CODE3(varpush,(Inst)yypvt[-2].sym,modeq); yyval.inst=yypvt[-0].inst; } break;
case 19:
# line 210 "hoc.y"
{ CODE3(varpush,(Inst)yypvt[-2].sym,assign); yyval.inst=yypvt[-0].inst; } break;
case 20:
# line 211 "hoc.y"
{ CODE3(varpush,(Inst)yypvt[-2].sym,const_assign); yyval.inst=yypvt[-0].inst; } break;
case 21:
# line 212 "hoc.y"
{ CODE3(varpush,(Inst)yypvt[-2].sym,addeq); yyval.inst=yypvt[-0].inst; } break;
case 22:
# line 213 "hoc.y"
{ CODE3(varpush,(Inst)yypvt[-2].sym,subeq); yyval.inst=yypvt[-0].inst; } break;
case 23:
# line 214 "hoc.y"
{ CODE3(varpush,(Inst)yypvt[-2].sym,muleq); yyval.inst=yypvt[-0].inst; } break;
case 24:
# line 215 "hoc.y"
{ CODE3(varpush,(Inst)yypvt[-2].sym,diveq); yyval.inst=yypvt[-0].inst; } break;
case 25:
# line 216 "hoc.y"
{ CODE3(varpush,(Inst)yypvt[-2].sym,modeq); yyval.inst=yypvt[-0].inst; } break;
case 26:
# line 217 "hoc.y"
{ defnonly("$"); CODE2(argassign,(Inst)yypvt[-2].narg); yyval.inst=yypvt[-0].inst;} break;
case 27:
# line 218 "hoc.y"
{ defnonly("$"); CODE2(argaddeq,(Inst)yypvt[-2].narg); yyval.inst=yypvt[-0].inst;} break;
case 28:
# line 219 "hoc.y"
{ defnonly("$"); CODE2(argsubeq,(Inst)yypvt[-2].narg); yyval.inst=yypvt[-0].inst;} break;
case 29:
# line 220 "hoc.y"
{ defnonly("$"); CODE2(argmuleq,(Inst)yypvt[-2].narg); yyval.inst=yypvt[-0].inst;} break;
case 30:
# line 221 "hoc.y"
{ defnonly("$"); CODE2(argdiveq,(Inst)yypvt[-2].narg); yyval.inst=yypvt[-0].inst;} break;
case 31:
# line 222 "hoc.y"
{ defnonly("$"); CODE2(argmodeq,(Inst)yypvt[-2].narg); yyval.inst=yypvt[-0].inst;} break;
case 32:
# line 225 "hoc.y"
{CODE3(varpush,(Inst)yypvt[-2].sym,str_assign); yyval.inst=yypvt[-0].inst; } break;
case 33:
# line 226 "hoc.y"
{CODE3(varpush,(Inst)yypvt[-2].sym,const_str_assign); yyval.inst=yypvt[-0].inst; } break;
case 34:
# line 227 "hoc.y"
{ defnonly("$"); CODE2(argassign,(Inst)yypvt[-2].narg); yyval.inst=yypvt[-0].inst;} break;
case 35:
# line 228 "hoc.y"
{CODE3(varpush,(Inst)yypvt[-2].sym,str_assign); yyval.inst=yypvt[-0].inst; } break;
case 36:
# line 229 "hoc.y"
{CODE3(varpush,(Inst)yypvt[-2].sym,const_str_assign); yyval.inst=yypvt[-0].inst; } break;
case 37:
# line 232 "hoc.y"
{ CODE(xpop); } break;
case 38:
# line 233 "hoc.y"
{ CODE(xpop); } break;
case 39:
# line 234 "hoc.y"
{ defnonly("return"); CODE(procret); } break;
case 40:
# line 235 "hoc.y"
{ defnonly("return"); yyval.inst=yypvt[-0].inst; CODE(funcret); } break;
case 41:
# line 236 "hoc.y"
{ yyval.inst = yypvt[-3].inst; CODE3(call, (Inst)yypvt[-4].sym, (Inst)yypvt[-1].narg); } break;
case 42:
# line 237 "hoc.y"
{ yyval.inst = yypvt[-0].inst; } break;
case 43:
# line 238 "hoc.y"
{ yyval.inst = yypvt[-0].inst; } break;
case 44:
# line 239 "hoc.y"
{ yyval.inst = yypvt[-0].inst; CODE(prnl); } break;
case 45:
# line 240 "hoc.y"
{
		(yypvt[-5].inst)[1] = (Inst)yypvt[-1].inst;	/* body of loop */
		(yypvt[-5].inst)[2] = (Inst)yypvt[-0].inst; } break;
case 46:
# line 243 "hoc.y"
{
		(yypvt[-9].inst)[1] = (Inst)yypvt[-5].inst;	/* condition */
		(yypvt[-9].inst)[2] = (Inst)yypvt[-3].inst;	/* post loop */
		(yypvt[-9].inst)[3] = (Inst)yypvt[-1].inst;	/* body of loop */
		(yypvt[-9].inst)[4] = (Inst)yypvt[-0].inst; } break;
case 47:
# line 248 "hoc.y"
{	/* else-less if */
		(yypvt[-5].inst)[1] = (Inst)yypvt[-1].inst;	/* thenpart */
		(yypvt[-5].inst)[3] = (Inst)yypvt[-0].inst; } break;
case 48:
# line 251 "hoc.y"
{	/* if with else */
		(yypvt[-8].inst)[1] = (Inst)yypvt[-4].inst;	/* thenpart */
		(yypvt[-8].inst)[2] = (Inst)yypvt[-1].inst;	/* elsepart */
		(yypvt[-8].inst)[3] = (Inst)yypvt[-0].inst; } break;
case 49:
# line 255 "hoc.y"
{ yyval.inst = yypvt[-1].inst; } break;
case 50:
# line 257 "hoc.y"
{ CODE(STOP); } break;
case 51:
# line 259 "hoc.y"
{ yyval.inst = code3(whilecode,STOP,STOP); } break;
case 52:
# line 261 "hoc.y"
{ yyval.inst = code(forcode); CODE4(STOP,STOP,STOP,STOP); } break;
case 53:
# line 263 "hoc.y"
{ yyval.inst = code(ifcode); CODE3(STOP,STOP,STOP); } break;
case 54:
# line 265 "hoc.y"
{ yyval.inst = progp; } break;
case 55:
# line 267 "hoc.y"
{ CODE(STOP); yyval.inst = progp; } break;
case 92:
# line 312 "hoc.y"
{ yyval.inst = progp; } break;
case 95:
# line 317 "hoc.y"
{ yyval.inst = code2(const_str_push, (Inst)yypvt[-0].sym); } break;
case 96:
# line 318 "hoc.y"
{ yyval.inst = code3(varpush, (Inst)yypvt[-0].sym, streval); } break;
case 97:
# line 319 "hoc.y"
{ defnonly("$$"); yyval.inst = code2(strarg, (Inst)yypvt[-0].narg); } break;
case 99:
# line 321 "hoc.y"
{ yyval.inst = yypvt[-1].inst; } break;
case 100:
# line 322 "hoc.y"
{ CODE(hexfp); } break;
case 101:
# line 323 "hoc.y"
{ CODE(hexint); } break;
case 102:
# line 324 "hoc.y"
{ CODE(numtostr); } break;
case 103:
# line 325 "hoc.y"
{ yyval.inst = code2(varread, (Inst)yypvt[-1].sym); } break;
case 104:
# line 326 "hoc.y"
{ CODE2(strbltin0, (Inst)yypvt[-2].sym->u.ptr0); } break;
case 105:
# line 327 "hoc.y"
{ yyval.inst = yypvt[-1].inst; CODE2(strbltin1, (Inst)yypvt[-3].sym->u.ptr1); } break;
case 106:
# line 328 "hoc.y"
{ yyval.inst = yypvt[-3].inst; CODE2(strbltin2, (Inst)yypvt[-5].sym->u.ptr2); } break;
case 107:
# line 329 "hoc.y"
{ CODE(str_strftime); yyval.inst = yypvt[-3].inst; } break;
case 108:
# line 330 "hoc.y"
{ CODE(str_to_symstr); yyval.inst = yypvt[-1].inst; } break;
case 109:
# line 331 "hoc.y"
{ CODE(str_substr); yyval.inst = yypvt[-5].inst; } break;
case 111:
# line 335 "hoc.y"
{ CODE3(constpush, (Inst)yypvt[-0].sym, str_concat_nn); } break;
case 112:
# line 336 "hoc.y"
{ CODE3(constpush, (Inst)yypvt[-0].sym, str_concat_ns); } break;
case 113:
# line 337 "hoc.y"
{ CODE(str_concat_ns); } break;
case 114:
# line 338 "hoc.y"
{ CODE3(constpush, (Inst)yypvt[-0].sym, str_concat_sn); } break;
case 115:
# line 339 "hoc.y"
{ CODE3(constpush, (Inst)yypvt[-0].sym, str_concat_sn); } break;
case 116:
# line 340 "hoc.y"
{ CODE(str_concat_ss); } break;
case 117:
# line 343 "hoc.y"
{ yyval.inst = code2(constpush, (Inst)yypvt[-0].sym); } break;
case 118:
# line 344 "hoc.y"
{ yyval.inst = code3(varpush, (Inst)yypvt[-0].sym, eval); } break;
case 119:
# line 345 "hoc.y"
{ defnonly("$"); yyval.inst = code2(arg, (Inst)yypvt[-0].narg); } break;
case 121:
# line 347 "hoc.y"
{ yyval.inst = yypvt[-3].inst; CODE3(call,(Inst)yypvt[-4].sym,(Inst)yypvt[-1].narg); } break;
case 122:
# line 348 "hoc.y"
{ yyval.inst = code2(varread, (Inst)yypvt[-1].sym); } break;
case 123:
# line 349 "hoc.y"
{ yyval.inst = code2(abort_user, (Inst)yypvt[-1].sym); } break;
case 124:
# line 350 "hoc.y"
{ yyval.inst = code2(Defined, (Inst)yypvt[-1].sym); } break;
case 125:
# line 351 "hoc.y"
{ yyval.inst = code2(Defined, (Inst)yypvt[-1].sym); } break;
case 126:
# line 352 "hoc.y"
{ yyval.inst = code2(Delete, (Inst)yypvt[-1].sym); } break;
case 127:
# line 353 "hoc.y"
{ yyval.inst = code2(Delete, (Inst)yypvt[-1].sym); } break;
case 128:
# line 354 "hoc.y"
{ CODE(hex); } break;
case 129:
# line 355 "hoc.y"
{ CODE2(bltin0, (Inst)yypvt[-2].sym->u.ptr0); } break;
case 130:
# line 356 "hoc.y"
{ yyval.inst = yypvt[-1].inst; CODE2(bltin1, (Inst)yypvt[-3].sym->u.ptr1); } break;
case 131:
# line 357 "hoc.y"
{ yyval.inst = yypvt[-3].inst; CODE2(bltin2, (Inst)yypvt[-5].sym->u.ptr2); } break;
case 132:
# line 358 "hoc.y"
{ CODE(str_index); yyval.inst = yypvt[-1].inst; } break;
case 133:
# line 359 "hoc.y"
{ CODE(str_length); yyval.inst = yypvt[-1].inst; } break;
case 134:
# line 360 "hoc.y"
{ CODE(str_to_symnum); yyval.inst = yypvt[-1].inst; } break;
case 135:
# line 361 "hoc.y"
{ CODE(str_to_num); yyval.inst = yypvt[-1].inst; } break;
case 136:
# line 362 "hoc.y"
{ yyval.inst = yypvt[-1].inst; } break;
case 137:
# line 363 "hoc.y"
{ CODE(add); } break;
case 138:
# line 364 "hoc.y"
{ CODE(sub); } break;
case 139:
# line 365 "hoc.y"
{ CODE(mul); } break;
case 140:
# line 366 "hoc.y"
{ CODE(divop); } break;
case 141:
# line 367 "hoc.y"
{ CODE(mod); } break;
case 142:
# line 368 "hoc.y"
{ CODE(power); } break;
case 143:
# line 369 "hoc.y"
{ yyval.inst=yypvt[-0].inst; CODE(negate); } break;
case 144:
# line 370 "hoc.y"
{ yyval.inst=yypvt[-0].inst; CODE(noop); } break;
case 145:
# line 371 "hoc.y"
{ CODE(gt); } break;
case 146:
# line 372 "hoc.y"
{ CODE(ge); } break;
case 147:
# line 373 "hoc.y"
{ CODE(lt); } break;
case 148:
# line 374 "hoc.y"
{ CODE(ltgt); } break;
case 149:
# line 375 "hoc.y"
{ CODE(le); } break;
case 150:
# line 376 "hoc.y"
{ CODE(eq); } break;
case 151:
# line 377 "hoc.y"
{ CODE(ne); } break;
case 152:
# line 378 "hoc.y"
{ CODE(And); } break;
case 153:
# line 379 "hoc.y"
{ CODE(Or); } break;
case 154:
# line 380 "hoc.y"
{ yyval.inst = yypvt[-0].inst; CODE(Not); } break;
case 155:
# line 381 "hoc.y"
{ yyval.inst = code2(preinc,(Inst)yypvt[-0].sym); } break;
case 156:
# line 382 "hoc.y"
{ yyval.inst = code2(predec,(Inst)yypvt[-0].sym); } break;
case 157:
# line 383 "hoc.y"
{ yyval.inst = code2(postinc,(Inst)yypvt[-1].sym); } break;
case 158:
# line 384 "hoc.y"
{ yyval.inst = code2(postdec,(Inst)yypvt[-1].sym); } break;
case 159:
# line 385 "hoc.y"
{ CODE(str_gt); } break;
case 160:
# line 386 "hoc.y"
{ CODE(str_ge); } break;
case 161:
# line 387 "hoc.y"
{ CODE(str_lt); } break;
case 162:
# line 388 "hoc.y"
{ CODE(str_le); } break;
case 163:
# line 389 "hoc.y"
{ CODE(str_eq); } break;
case 164:
# line 390 "hoc.y"
{ CODE(str_ne); } break;
case 165:
# line 393 "hoc.y"
{ CODE(prexpr); } break;
case 166:
# line 394 "hoc.y"
{ CODE(prstr); } break;
case 167:
# line 395 "hoc.y"
{ CODE2(prsep,prexpr); } break;
case 168:
# line 396 "hoc.y"
{ CODE2(prsep,prstr); } break;
case 169:
# line 399 "hoc.y"
{ CODE(prfmt); } break;
case 170:
# line 400 "hoc.y"
{ CODE(prexpr); } break;
case 171:
# line 401 "hoc.y"
{ CODE(prstr); } break;
case 172:
# line 404 "hoc.y"
{ yypvt[-0].sym->type=FUNCTION; indef=1; } break;
case 173:
# line 405 "hoc.y"
{ CODE(procret); define(yypvt[-4].sym); indef=0; } break;
case 174:
# line 406 "hoc.y"
{ yypvt[-0].sym->type=PROCEDURE; indef=1; } break;
case 175:
# line 407 "hoc.y"
{ CODE(procret); define(yypvt[-4].sym); indef=0; } break;
case 179:
# line 415 "hoc.y"
{ yyval.narg = 0; } break;
case 180:
# line 416 "hoc.y"
{ yyval.narg = 1; } break;
case 181:
# line 417 "hoc.y"
{ yyval.narg = 1; } break;
case 182:
# line 418 "hoc.y"
{ yyval.narg = yypvt[-2].narg + 1; } break;
case 183:
# line 419 "hoc.y"
{ yyval.narg = yypvt[-2].narg + 1; } break;
# line	531 "/usr/ccs/bin/yaccpar"
	}
	goto yystack;		/* reset registers in driver code */
}

